unit CopyMeta;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls, AdvPanel,
  Vcl.ComCtrls;

type
  TFCopyMetadata = class(TForm)
    StatusBar1: TStatusBar;
    AdvPanel1: TAdvPanel;
    CheckBox1: TCheckBox;
    Label2: TLabel;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    CheckBox5: TCheckBox;
    Button1: TButton;
    Label1: TLabel;
    Button2: TButton;
    CheckBox6: TCheckBox;
    CheckBox7: TCheckBox;
    CheckBox8: TCheckBox;
    Label3: TLabel;
    procedure FormShow(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
    procedure DisplayHint(Sender: TObject);
  public
    { Public declarations }
  end;

var
  FCopyMetadata: TFCopyMetadata;

implementation
uses Main;
{$R *.dfm}
var clLite,clDark:TColor;

procedure TFCopyMetadata.FormShow(Sender: TObject);
begin
  Left:=FMain.Left+FMain.GUIBorderWidth+FMain.AdvPageFilelist.Left;
  Top:=FMain.Top+FMain.GUIBorderHeight;

  clLite:=FMain.GUIclLite; clDark:=FMain.GUIclDark;
  Color:=clDark;
  with AdvPanel1 do begin
    ParentBackground:=false; //because of CheckBox-es
    Color:=clLite; ColorTo:=clNone;
  end;

  if FMain.MDontBackup.Checked then Label1.Caption:='Backup: OFF'
                               else Label1.Caption:='Backup: ON';
  Application.OnHint:=DisplayHint;
end;

procedure TFCopyMetadata.Button2Click(Sender: TObject);
begin
  ModalResult:=mrOK;
end;

procedure TFCopyMetadata.DisplayHint(Sender: TObject);
begin
  StatusBar1.SimpleText:=GetShortHint(Application.Hint);
end;

end.
