unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.Grids, Vcl.ValEdit, ShellLink,
  Vcl.ComCtrls, JamControls, ShellControls, Vcl.ExtCtrls, AdvPageControl,
  AdvPanel, Vcl.Menus, Vcl.Buttons, Vcl.StdCtrls, ShellBrowser, RotImg,
  Vcl.ExtDlgs, Vcl.OleCtrls, SHDocVw, RSChartPanel, RSCharts, AdvOfficeButtons,
  AdvGroupBox;

type
  TFMain = class(TForm)
    MainMenu: TMainMenu;
    MProgram: TMenuItem;
    MAbout: TMenuItem;
    StatusBar: TStatusBar;
    AdvPanelBrowse: TAdvPanel;
    AdvPageBrowse: TAdvPageControl;
    AdvTabBrowse: TAdvTabSheet;
    AdvPagePreview: TAdvPageControl;
    AdvTabPreview: TAdvTabSheet;
    AdvPageMetadata: TAdvPageControl;
    AdvTabMetadata: TAdvTabSheet;
    AdvPageFilelist: TAdvPageControl;
    AdvTabFilelist: TAdvTabSheet;
    AdvPanelFileTop: TAdvPanel;
    AdvPanelETdirect: TAdvPanel;
    AdvPanelMetaTop: TAdvPanel;
    AdvPanelMetaBottom: TAdvPanel;
    ShellTree: TJamShellTree;
    ShellList: TJamShellList;
    ShellLink: TJamShellLink;
    MetadataList: TValueListEditor;
    SpeedBtnExif: TSpeedButton;
    SpeedBtnIptc: TSpeedButton;
    SpeedBtnXmp: TSpeedButton;
    SpeedBtnMaker: TSpeedButton;
    SpeedBtnALL: TSpeedButton;
    SpeedBtnCustom: TSpeedButton;
    Splitter1: TSplitter;
    Splitter2: TSplitter;
    Splitter3: TSplitter;
    SpeedBtnDetails: TSpeedButton;
    CBoxDetails: TComboBox;
    ShellBrowser: TShellBrowser;
    RotateImg: TRotateImage;
    EditETdirect: TLabeledEdit;
    LabelCounter: TLabel;
    SpeedBtn_ETdirect: TSpeedButton;
    CBoxETdirect: TComboBox;
    SpeedBtn_ETedit: TSpeedButton;
    EditETcmdName: TLabeledEdit;
    CBoxFileFilter: TComboBox;
    SpeedBtnQuick: TSpeedButton;
    MPreferences: TMenuItem;
    MOptions: TMenuItem;
    MDontBackup: TMenuItem;
    MPreserveDateMod: TMenuItem;
    MIgnoreErrors: TMenuItem;
    N1: TMenuItem;
    MShowGPSdecimal: TMenuItem;
    MShowNumbers: TMenuItem;
    QuickPopUpMenu: TPopupMenu;
    QuickPopUp_UndoEdit: TMenuItem;
    QuickPopUp_MarkTag: TMenuItem;
    QuickPopUp_AddCustom: TMenuItem;
    QuickPopUp_DelCustom: TMenuItem;
    QuickPopUp_AddQuick: TMenuItem;
    MQuickManager: TMenuItem;
    N5: TMenuItem;
    MExit: TMenuItem;
    MemoQuick: TMemo;
    SpeedBtnLarge: TSpeedButton;
    QuickPopUp_DelQuick: TMenuItem;
    MModify: TMenuItem;
    MExifDateTimeshift: TMenuItem;
    EditQuick: TEdit;
    MShowHexID: TMenuItem;
    MGroup_g4: TMenuItem;
    MGUIColorBlue: TMenuItem;
    MGUIColorGreen: TMenuItem;
    SpeedBtnFListRefresh: TSpeedButton;
    SpeedBtnFilterEdit: TSpeedButton;
    SpeedBtnColumnEdit: TSpeedButton;
    SpeedBtnShowLog: TSpeedButton;
    SpeedBtnQuickSave: TSpeedButton;
    SpeedBtnETdirectDel: TSpeedButton;
    SpeedBtnETdirectReplace: TSpeedButton;
    SpeedBtnETdirectAdd: TSpeedButton;
    MGUIColorGrey: TMenuItem;
    MGUIcolor: TMenuItem;
    MExportImport: TMenuItem;
    MExportMeta: TMenuItem;
    MExportMetaTXT: TMenuItem;
    MExportMetaMIE: TMenuItem;
    MExportMetaXMP: TMenuItem;
    MExportMetaHTM: TMenuItem;
    MImportMetaSelected: TMenuItem;
    OpenPictureDlg: TOpenPictureDialog;
    MImportGPS: TMenuItem;
    MImportGPSLog: TMenuItem;
    MImportXMPLog: TMenuItem;
    N7: TMenuItem;
    MExtractPreview: TMenuItem;
    MJPGfromCR2: TMenuItem;
    MJPGfromNEF: TMenuItem;
    MJPGfromRW2: TMenuItem;
    MExifDateTimeEqualize: TMenuItem;
    N8: TMenuItem;
    MRemoveMeta: TMenuItem;
    MExifLensFromMaker: TMenuItem;
    MVarious: TMenuItem;
    MFileDateFromExif: TMenuItem;
    MJPGAutorotate: TMenuItem;
    MEmbedPreview: TMenuItem;
    MJPGtoCR2: TMenuItem;
    MExportMetaEXIF: TMenuItem;
    MShowSorted: TMenuItem;
    N6: TMenuItem;
    QuickPopUp_FillQuick: TMenuItem;
    MShowComposite: TMenuItem;
    AdvTabGoogleMap: TAdvTabSheet;
    AdvPanel_MapTop: TAdvPanel;
    WebBrowser1: TWebBrowser;
    SpeedBtn_ShowOnMap: TSpeedButton;
    AdvPanel_MapBottom: TAdvPanel;
    SpeedBtn_Geotag: TSpeedButton;
    SpeedBtn_GetLoc: TSpeedButton;
    EditMapFind: TLabeledEdit;
    SpeedBtn_MapHome: TSpeedButton;
    SpeedBtn_MapSetHome: TSpeedButton;
    MapTrackBar: TTrackBar;
    N2: TMenuItem;
    QuickPopUp_AddDetailsUser: TMenuItem;
    MImportMetaSingle: TMenuItem;
    MNotDuplicated: TMenuItem;
    N3: TMenuItem;
    QuickPopUp_CopyTag: TMenuItem;
    MFileNameDateTime: TMenuItem;
    MWorkspace: TMenuItem;
    MWorkspaceLoad: TMenuItem;
    MWorkspaceSave: TMenuItem;
    OpenFileDlg: TOpenDialog;
    SaveFileDlg: TSaveDialog;
    AdvTabChart: TAdvTabSheet;
    AdvPanel1: TAdvPanel;
    SpeedBtnChartRefresh: TSpeedButton;
    RSChartPanel1: TRSChartPanel;
    RSBarChart1: TRSBarChart;
    RSBarChart2: TRSBarChart;
    RSBarChart3: TRSBarChart;
    AdvCheckBox_Subfolders: TAdvOfficeCheckBox;
    AdvRadioGroup1: TAdvOfficeRadioGroup;
    AdvRadioGroup2: TAdvOfficeRadioGroup;
    MImportRecursiveAll: TMenuItem;
    SpeedBtn_ETdSetDef: TSpeedButton;
    SpeedBtn_ETclear: TSpeedButton;
    procedure ShellListClick(Sender: TObject);
    procedure ShellListKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ShellTreeChange(Sender: TObject; Node: TTreeNode);
    procedure SpeedBtnExifClick(Sender: TObject);
    procedure CBoxDetailsDropDown(Sender: TObject);
    procedure CBoxDetailsChange(Sender: TObject);
    procedure ShellListAddItem(Item: TJamShellListItem; var CanAdd: Boolean);
    procedure FormShow(Sender: TObject);
    procedure ShellListCreateColumns(Sender: TObject);
    procedure SpeedBtnDetailsClick(Sender: TObject);
    procedure RotateImgResize(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure EditETdirectKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure SpeedBtn_ETdirectClick(Sender: TObject);
    procedure CBoxETdirectChange(Sender: TObject);
    procedure SpeedBtn_ETeditClick(Sender: TObject);
    procedure EditETdirectChange(Sender: TObject);
    procedure EditETcmdNameChange(Sender: TObject);
    procedure BtnETdirectDelClick(Sender: TObject);
    procedure BtnETdirectReplaceClick(Sender: TObject);
    procedure BtnETdirectAddClick(Sender: TObject);
    procedure BtnFListRefreshClick(Sender: TObject);
    procedure CBoxFileFilterChange(Sender: TObject);
    procedure MetadataListDrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure MetadataListSelectCell(Sender: TObject; ACol, ARow: Integer;
      var CanSelect: Boolean);
    procedure MetadataListKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure MetadataListExit(Sender: TObject);
    procedure EditQuickEnter(Sender: TObject);
    procedure EditQuickExit(Sender: TObject);
    procedure EditQuickKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ShellListPathChanged(Sender: TObject);
    procedure BtnQuickSaveClick(Sender: TObject);
    procedure MPreferencesClick(Sender: TObject);
    procedure BtnFilterEditClick(Sender: TObject);
    procedure CBoxFileFilterKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure BtnColumnEditClick(Sender: TObject);
    procedure BtnShowLogClick(Sender: TObject);
    procedure ShellListDeletion(Sender: TObject; Item: TListItem);
    procedure MDontBackupClick(Sender: TObject);
    procedure MPreserveDateModClick(Sender: TObject);
    procedure MIgnoreErrorsClick(Sender: TObject);
    procedure MShowNumbersClick(Sender: TObject);
    procedure Splitter1CanResize(Sender: TObject; var NewSize: Integer;
      var Accept: Boolean);
    procedure Splitter2CanResize(Sender: TObject; var NewSize: Integer;
      var Accept: Boolean);
    procedure FormCanResize(Sender: TObject; var NewWidth, NewHeight: Integer;
      var Resize: Boolean);
    procedure Splitter3CanResize(Sender: TObject; var NewSize: Integer;
      var Accept: Boolean);
    procedure ShellListChange(Sender: TObject; Item: TListItem;
      Change: TItemChange);
    procedure QuickPopUpMenuPopup(Sender: TObject);
    procedure QuickPopUp_UndoEditClick(Sender: TObject);
    procedure QuickPopUp_MarkTagClick(Sender: TObject);
    procedure QuickPopUp_AddCustomClick(Sender: TObject);
    procedure QuickPopUp_DelCustomClick(Sender: TObject);
    procedure QuickPopUp_AddQuickClick(Sender: TObject);
    procedure MQuickManagerClick(Sender: TObject);
    procedure MExitClick(Sender: TObject);
    procedure SpeedBtnLargeClick(Sender: TObject);
    procedure QuickPopUp_DelQuickClick(Sender: TObject);
    procedure MExifDateTimeshiftClick(Sender: TObject);
    procedure MGUIColorGreyClick(Sender: TObject);
    procedure MExportMetaTXTClick(Sender: TObject);
    procedure MImportGPSLogClick(Sender: TObject);
    procedure MImportXMPLogClick(Sender: TObject);
    procedure MJPGfromCR2Click(Sender: TObject);
    procedure MExifDateTimeEqualizeClick(Sender: TObject);
    procedure MRemoveMetaClick(Sender: TObject);
    procedure MExifLensFromMakerClick(Sender: TObject);
    procedure MFileDateFromExifClick(Sender: TObject);
    procedure MJPGAutorotateClick(Sender: TObject);
    procedure MJPGtoCR2Click(Sender: TObject);
    procedure ShellListOperation(Sender: TObject;
      Operation: TJamShellOperations; Files: TStrings; Destination: string);
    procedure MAboutClick(Sender: TObject);
    procedure QuickPopUp_FillQuickClick(Sender: TObject);
    procedure SpeedBtn_GeotagClick(Sender: TObject);
    procedure SpeedBtn_ShowOnMapClick(Sender: TObject);
    procedure SpeedBtn_GetLocClick(Sender: TObject);
    procedure SpeedBtn_MapHomeClick(Sender: TObject);
    procedure EditMapFindChange(Sender: TObject);
    procedure EditMapFindKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure SpeedBtn_MapSetHomeClick(Sender: TObject);
    procedure MapTrackBarChange(Sender: TObject);
    procedure QuickPopUp_AddDetailsUserClick(Sender: TObject);
    procedure MImportMetaSingleClick(Sender: TObject);
    procedure QuickPopUp_CopyTagClick(Sender: TObject);
    procedure MFileNameDateTimeClick(Sender: TObject);
    procedure MetadataListMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure MWorkspaceLoadClick(Sender: TObject);
    procedure MWorkspaceSaveClick(Sender: TObject);
    procedure SpeedBtnChartRefreshClick(Sender: TObject);
    procedure AdvRadioGroup2Click(Sender: TObject);
    procedure MImportRecursiveAllClick(Sender: TObject);
    procedure MImportMetaSelectedClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure SpeedBtn_ETdSetDefClick(Sender: TObject);
    procedure SpeedBtn_ETclearClick(Sender: TObject);
  private
    { Private declarations }
    originalPanelWindowProc: TWndMethod;
    procedure PanelWindowProc(var Msg:TMessage);
    procedure PanelImageDrop(var Msg:TWMDROPFILES);
    //-- ^drag_drop ImgFile from WinExplorer --
    procedure ShowMetadata; //(const LogErr:boolean=true);
    procedure ShowPreview;
    procedure WMEndSession(var Msg:TWMEndSession); message WM_ENDSESSION;
    procedure QuickFilelistRefresh;
    function TranslateTagName(xMeta,xName:string):string;
  public
    { Public declarations }
    function GetSelectedFiles(forETopen:boolean=true): string;
    procedure DeleteTmpFile;
    procedure UpdateLogWin;
    procedure UpdateStatusBar_FilesShown;
    procedure ChangeGUIcolor;
    var GUIBorderWidth,GUIBorderHeight:integer; //Initialized in OnShow
    var GUIclLite,GUIclDark: TColor;
  end;

var
  FMain: TFMain;

implementation
uses StrUtils, ExifTool, ExifInfo, MainDef, LogWin, Preferences, EditFFilter, EditFCol,
     QuickMngr, DateTimeShift, DateTimeEqual, CopyMeta, RemoveMeta, Geotag, Geomap,
     ClipBrd, CopyMetaSingle, FileDateTime, ShellApi;
{$R *.dfm}
const
  GUI_SEP='-GUI-SEP';
var
  TmpFileUsed: boolean;
  GUIFormatSettings: TFormatSettings;

procedure TFMain.WMEndSession(var Msg: TWMEndSession) ;
begin //for Windows Shutdown/Log-off while GUI is open
  if Msg.EndSession=TRUE then SaveGUIini; inherited;
end;

procedure TFMain.ChangeGUIcolor;
var i,j: smallint;
begin
  for i:=0 to ComponentCount-1 do begin
    if Components[i] is TSplitter then with Components[i] as TSplitter do Color:=GUIclDark;
    if Components[i] is TAdvPageControl then with Components[i] as TAdvPageControl do begin
      TabBackGroundColor:=GUIclDark; ActiveColor:=GUIclLite;
      for j:=0 to PageCount-1 do with Pages[j] do begin
        Color:=GUIclLite; ColorTo:=GUIclDark; TabColor:=GUIclDark;
      end;
    end;
    if Components[i] is TAdvPanel then with Components[i] as TAdvPanel do begin
      Color:=GUIclLite; ColorTo:=GUIclDark; ColorMirror:=GUIclDark; ColorMirrorTo:=GUIclDark;
    end;
  end;
end;

procedure TFMain.QuickPopUp_CopyTagClick(Sender: TObject);
begin
  Clipboard.AsText:=MetadataList.Cells[1,MetadataList.Row];
end;

procedure TFMain.AdvRadioGroup2Click(Sender: TObject);
begin
  case AdvRadioGroup2.ItemIndex of
    0: begin
         RSBarChart2.Visible:=false; RSBarChart3.Visible:=false;
         RSChartPanel1.LeftAxis.Maximum:=ChartMaxFLength;
         RSChartPanel1.BottomAxis.Title.Text:='Focal length';
         RSBarChart1.Visible:=true;
       end;
    1: begin
         RSBarChart1.Visible:=false; RSBarChart3.Visible:=false;
         RSChartPanel1.LeftAxis.Maximum:=ChartMaxFNumber;
         RSChartPanel1.BottomAxis.Title.Text:='F-Number';
         RSBarChart2.Visible:=true;
       end;
    2: begin
         RSBarChart1.Visible:=false; RSBarChart2.Visible:=false;
         RSChartPanel1.LeftAxis.Maximum:=ChartMaxISO;
         RSChartPanel1.BottomAxis.Title.Text:='ISO';
         RSBarChart3.Visible:=true;
       end;
  end;
end;

procedure TFMain.BtnColumnEditClick(Sender: TObject);
begin
  if FEditFColumn.ShowModal=mrOK then begin
    with ShellList do begin
      OnClick:=nil;
      FullRefresh;
      SetFocus;
      OnClick:=ShellListClick;
    end;
    ShowMetadata; //ShowPreview;
  end;
end;

procedure TFMain.BtnETdirectAddClick(Sender: TObject);
begin
  EditETdirect.Text:=trim(EditETdirect.Text);
  ETdirectCmd.Append(EditETdirect.Text); //store command
  EditETcmdName.Text:=trim(EditETcmdName.Text);
  CBoxETdirect.ItemIndex:=CBoxETdirect.Items.Add(EditETcmdName.Text); //store name
  CBoxETdirectChange(Sender);
end;

procedure TFMain.BtnETdirectDelClick(Sender: TObject);
var i:smallint;
begin
  i:=CBoxETdirect.ItemIndex; CBoxETdirect.ItemIndex:=-1;
  ETdirectCmd.Delete(i); CBoxETdirect.Items.Delete(i);
  EditETcmdName.Text:=''; EditETcmdName.Modified:=false;
  EditETdirect.Modified:=true;
  CBoxETdirectChange(Sender);
end;

procedure TFMain.BtnETdirectReplaceClick(Sender: TObject);
var i:smallint;
begin
  i:=CBoxETdirect.ItemIndex; CBoxETdirect.ItemIndex:=-1;
  EditETdirect.Text:=trim(EditETdirect.Text);
  ETdirectCmd[i]:=EditETdirect.Text;
  EditETcmdName.Text:=trim(EditETcmdName.Text);
  CBoxETdirect.Items[i]:=EditETcmdName.Text; CBoxETdirect.ItemIndex:=i;
  CBoxETdirectChange(Sender);
end;

procedure TFMain.BtnFilterEditClick(Sender: TObject);
var i,n,x:smallint;
begin
  if FEditFFilter.ShowModal=mrOK then with CBoxFileFilter do begin
    x:=ItemIndex;
    OnChange:=nil;
    i:=FEditFFilter.ListBox1.Items.Count-1;
    Items.Clear;
    for n:=0 to i do Items.Append(FEditFFilter.ListBox1.Items[n]);
    OnChange:=CBoxFileFilterChange;
    ItemIndex:=0;
    if x<>0 then CBoxFileFilterChange(Sender);
  end;
end;

procedure TFMain.QuickFilelistRefresh;
var i,n:integer;
  SelectedFNames: TStrings;
  xFile: string;
begin
  SelectedFNames:=TStringList.Create;
  SelectedFNames.AddStrings(ShellList.SelectedFiles);
  i:=SelectedFNames.Count-1;
  try
    with ShellList do begin
      ClearSelection; FullRefresh;
      n:=Items.Count-1;
      while i>=0 do begin
        xFile:=ExtractFileName(Items[n].FullPath);
        if xFile=SelectedFNames[i] then begin
          Items[n].Selected:=true; dec(i);
        end;
        dec(n);
      end;
    end;
  finally
    SelectedFnames.Free;
  end;
end;

procedure TFMain.BtnFListRefreshClick(Sender: TObject);
begin
  //QuickFilelistRefresh;
  ShellList.FullRefresh; // -use this (to be sure)
  ShowMetadata; ShowPreview;
  ShellList.SetFocus;
end;

procedure TFMain.BtnQuickSaveClick(Sender: TObject);
var i,j,k: smallint; //Rotated: boolean;
  ETcmd,TagValue,tx: AnsiString;

begin
  ETcmd:=''; SpeedBtnQuickSave.Enabled:=false;
  j:=MetadataList.RowCount-1; //Rotated:=false;
  for i:=1 to j do if pos('*',MetadataList.Keys[i])=1 then begin
    TagValue:=MetadataList.Cells[1,i];

    tx:=MetadataList.Keys[i];
    k:=pos(#177,tx);       //is it multi-value tag?
    if (k=0) or (TagValue='') then begin     //no: standard tag

      k:=0; if RightStr(tx,1)='#' then inc(k);
      tx:=LowerCase(QuickTags[i-1].Command);
      //if (pos('orientation',tx)>0) then Rotated:=true;
      if k>0 then begin
        if RightStr(tx,1)<>'#' then tx:=tx+'#';
      end;
      ETcmd:=ETcmd+tx+'='+TagValue+CRLF;

    end else begin //it is multi-value tag (ie.keywords)
      repeat
        ETcmd:=ETcmd+QuickTags[i-1].Command;
        case TagValue[1] of
        '+': begin ETcmd:=ETcmd+'+='; Delete(TagValue,1,1); end;
        '-': begin ETcmd:=ETcmd+'-='; Delete(TagValue,1,1); end;
        else ETcmd:=ETcmd+'=';
        end;
        k:=pos('+',TagValue);
        if k>0 then tx:=Copy(TagValue,1,k-1)
        else begin
          k:=pos('-',TagValue);
          if k>0 then tx:=Copy(TagValue,1,k-1) else tx:=TagValue;
        end;
        if k>0 then Delete(TagValue,1,k-1) else TagValue:='';
        ETcmd:=ETcmd+tx+CRLF;
      until length(TagValue)=0;
    end;
  end;

  if ET_OpenExec(ETcmd,GetSelectedFiles) then begin
    UpdateLogWin;
    QuickFilelistRefresh;
    ShowMetadata; ShowPreview; //if Rotated then ShowPreview;
  end;
  ETcmd:=''; tx:='';
  MetadataList.SetFocus;
  DeleteTmpFile;
end;

procedure TFMain.BtnShowLogClick(Sender: TObject);
begin
  FLogWin.Show;
end;

procedure TFMain.CBoxDetailsChange(Sender: TObject);
begin
  with CBoxDetails do
    SpeedBtnColumnEdit.Enabled:=SpeedBtnDetails.Down and (ItemIndex=Items.Count-1);
  with ShellList do begin
    OnClick:=nil;
    FullRefresh;
    SetFocus;
    OnClick:=ShellListClick;
  end;
  ShowMetadata; ShowPreview;
end;

function TFMain.GetSelectedFiles(forETopen:boolean=true): string;
var i,j: integer;
    F: TextFile;
begin
  result:=''; TmpFileUsed:=false;
  j:=ShellList.SelectedFiles.Count;
  if j>0 then begin
    ETcounter:=j;

    // -don't use that, because in case "all" files in dir are selected, files
    //  will be modified in subfolders too, if subfolder names contain a dot!
    (*
    i:=ShellList.Items.Count;
    if i=j then begin
      if forETopen then result:=ShellList.Filter+CRLF
                   else result:=' '+ShellList.Filter;
    end else begin
    *)
      dec(j);
      if (Length(ShellList.SelectedFiles.Text)+j)<28000 then begin//max params length=32768bytes
        if forETopen then
          for i:=0 to j do result:=result+ShellList.SelectedFiles[i]+CRLF
        else
          for i:=0 to j do result:=result+' ".\'+ShellList.SelectedFiles[i]+'"'
      end else begin
        TmpFileUsed:=true;
        AssignFile(F,'ExifToolGUI.tmp');
        Rewrite(F); //Create file (delete old if exist)
        for i:=0 to j do Writeln(F, ShellList.SelectedFiles[i]); //-writes Ansi encoded lines
        CloseFile(F);
        if forETopen then result:='-@'+CRLF+ExtractFilePath(Application.ExeName)+'ExifToolGUI.tmp'
                     else result:=' -@ '+ExtractFilePath(Application.ExeName)+'ExifToolGUI.tmp';
      end;
    //end;
  end;
end;

procedure TFMain.EditMapFindChange(Sender: TObject);
begin
  EditMapFind.Font.Color:=clBlue;
end;

procedure TFMain.EditMapFindKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Key=VK_Return) and (EditMapFind.Text<>'') then begin
    MapGotoPlace(EditMapFind.Text);
    EditMapFind.Font.Color:=clBlue;
  end;
end;

procedure TFMain.MGUIColorGreyClick(Sender: TObject);
var oldLite: TColor;
begin
  if Sender is TMenuItem then with Sender as TMenuItem do Checked:=true;
  oldLite:=GUIclLite;
  if Sender=MGUIColorGrey  then begin //grey
     GUIclLite:=$F0F0F0; GUIclDark:=$D0D0D0; GUIsettings.GUIcolor:=0; end;
  if Sender=MGUIColorBlue  then begin //blue
     GUIclLite:=$FFF7EB; GUIclDark:=$FFDAB6; GUIsettings.GUIcolor:=1; end;
  if Sender=MGUIColorGreen then begin //green
     GUIclLite:=$EBF5ED; GUIclDark:=$C0DCC0; GUIsettings.GUIcolor:=2; end;

  if GUIclLite<>oldLite then begin
    ChangeGUIcolor;
    MapTrackBar.Enabled:=false; MapTrackBar.Enabled:=true;
  end;
end;

procedure TFMain.MAboutClick(Sender: TObject);
var txt:string; i,x,y:smallint;

function GetFileVersionNumber(Fname:string; vShort:boolean):string;
var v,verInfoSize,verValueSize:longword; minor:word;
    verInfo:pointer; VerValue: PVSFixedFileInfo;
begin
  if vShort then begin
    v:=GetFileVersion(FName); minor:=v and $FFFF;
    result:=IntToStr(v shr 16)+'.'; if minor<10 then result:=result+'0';
    result:=result+IntToStr(minor);
  end else begin
    Result := '-.-.-.-';
    VerInfoSize:=GetFileVersionInfoSize(@FName[1],v);
    if VerInfoSize=0 then Exit;
    GetMem(VerInfo,VerInfoSize);
    GetFileVersionInfo(@FName[1],0,VerInfoSize,VerInfo);
    VerQueryValue(VerInfo,'\',Pointer(VerValue),VerValueSize);
    with VerValue^ do begin
      Result:=IntToStr(dwFileVersionMS shr 16);
      Result:=Result+'.'+IntToStr(dwFileVersionMS and $FFFF);
      Result:=Result+'.'+IntToStr(dwFileVersionLS shr 16);
      Result:=Result+'.'+IntToStr(dwFileVersionLS and $FFFF);
    end;
    FreeMem(VerInfo, VerInfoSize);
  end;
end;

begin
  txt:='ExifToolGUI v'+GetFileVersionNumber(Application.ExeName,false);
  txt:=txt+' by Bogdan Hrastnik';
  //txt:=txt+#10#13+'Freeware interface for Exiftool';
  txt:=txt+#10#13+'http://u88.n24.queensu.ca/exiftool/forum/   ';
  txt:=txt+#10#13+'---'+#10#13+'ExifTool by Phil Harvey ';
  if ExecET('exiftool -ver','','') then txt:=txt+'v'+ETout[0]
                                                 else txt:=txt+'MISSING!';
  txt:=txt+#10#13+'---'+#10#13+'jhead.exe=';
  if ExecCMD('jhead','') then txt:=txt+'ready' else txt:=txt+'missing';
  txt:=txt+',  jpegtran.exe=';
  if ExecCMD('jpegtran','') then txt:=txt+'ready' else txt:=txt+'missing';
  txt:=txt+#10#13+'---'+#10#13;
  x:=Screen.Width; y:=Screen.Height; i:=Screen.PixelsPerInch;
  txt:=txt+'Screen resolution: '+IntToStr(x)+'x'+IntToStr(y)+' at '+IntToStr(i)+'DPI';
  with CreateMessageDialog(txt,mtInformation,[mbOk]) do begin
   Caption:='About'; Color:=GUIclLite;
   ShowModal;
   Free; txt:='';
  end;
end;

procedure TFMain.MDontBackupClick(Sender: TObject);
begin
  with ET_Options do
    if MDontBackup.Checked then ETBackupMode:='-overwrite_original'+CRLF
    else ETBackupMode:='';
end;

procedure TFMain.MetadataListDrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
var CellTx, KeyTx, WorkTx: string[127]; NewColor,TxtColor: TColor;
    i,n,x:smallint;
begin
  n:=Length(QuickTags)-1;
  if (ARow>0) then with MetadataList do begin
    CellTx:=Cells[ACol,ARow];
    KeyTx:=Cells[0,ARow];
    if (KeyTx='') then with Canvas do begin //=Group line
      Brush.Style:=bsSolid;
      if ACol=0 then begin
        Brush.Color:=clWindow; //$F0F0F0;
        FillRect(Rect);
      end else begin  //ACol=1
        Brush.Color:=clWindow; Font.Style:=[fsBold]; Font.Color:=clWindowText;
        TextRect(Rect, Rect.Left+4, Rect.Top+2, CellTx);
      end;
    end else if (ACol=0) then begin //-remove "if ACol=0 then" to change both columns
      NewColor:=clWindow;
      if SpeedBtnQuick.Down then begin //=Edited tag
        if (KeyTx[1]='*') then NewColor:=$BBFFFF;
        if NewColor<>clWindow then with Canvas do begin
          Brush.Style:=bssolid;
          Brush.Color:=NewColor;
          Font.Color:=$BB0000;
          TextRect(Rect, Rect.Left+4, Rect.Top+2, CellTx);
        end;
      end else if GUIsettings.Language='' then begin //=Marked tag
        Delete(KeyTx,1,pos(' ',KeyTx)); //-in case of Show HexID prefix
        TxtColor:=clWindowText;
        if Pos(KeyTx+' ',MarkedTags)>0 then TxtColor:=$0000FF; //tag is marked
        // check if tag is defined in Workspace
        KeyTx:=UpperCase(KeyTx);
        for i:=0 to n do begin
          WorkTx:=UpperCase(QuickTags[i].Command);
          x:=pos(':',WorkTx); if x>0 then Delete(WorkTx,1,x);
          if KeyTx=WorkTx then begin
            NewColor:=$EEFFDD;  break;
          end;
        end;
        if (NewColor<>clWindow) or (TxtColor<>clWindowText) then with Canvas do begin
          Brush.Style:=bssolid;
          Brush.Color:=NewColor;
          Font.Color:=TxtColor;
          TextRect(Rect, Rect.Left+4, Rect.Top+2, CellTx);
        end;
      end;
    end;
  end;
end;

procedure TFMain.MetadataListExit(Sender: TObject);
begin  //remember last selected row
  if SpeedBtnQuick.Down then MetadataList.Tag:=MetadataList.Row;
end;

procedure TFMain.MetadataListKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var i:smallint;
begin
  i:=MetadataList.Row;
  if (Key=VK_RETURN) and SpeedBtnQuick.Down and not(QuickTags[i-1].NoEdit) then begin
    if SpeedBtnLarge.Down then MemoQuick.SetFocus
                          else EditQuick.SetFocus;
  end;
  if (Shift=[ssCTRL]) and (Key=Ord('C')) then
    Clipboard.AsText:=MetadataList.Cells[1,i];
end;

procedure TFMain.MetadataListMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var xCol,xRow: longint;
begin
  if Button=mbRight then with MetadataList do begin
    MouseToCell(X,Y,xCol,xRow); Row:=xRow;
  end;
end;

procedure TFMain.MetadataListSelectCell(Sender: TObject; ACol, ARow: Integer;
  var CanSelect: Boolean);
begin
  EditQuick.Text:=''; MemoQuick.Text:='';
  if SpeedBtnQuick.Down and not(QuickTags[ARow-1].NoEdit)
  then with MetadataList do begin
    if SpeedBtnLarge.Down then begin
      if RightStr(Keys[ARow],1)=#177 then MemoQuick.Text:='+'
                                     else MemoQuick.Text:=Cells[1,ARow];
    end else begin
      if RightStr(Keys[ARow],1)=#177 then EditQuick.Text:='+'
                                     else EditQuick.Text:=Cells[1,ARow];
    end;
  end;
end;

procedure TFMain.MExifDateTimeEqualizeClick(Sender: TObject);
begin
  if FDateTimeEqual.ShowModal=mrOK then begin
    UpdateLogWin;
    QuickFilelistRefresh;
    ShowMetadata;
  end;
end;

procedure TFMain.MExifDateTimeshiftClick(Sender: TObject);
begin
  if FDateTimeShift.ShowModal=mrOK then begin
    UpdateLogWin;
    QuickFilelistRefresh;
    ShowMetadata;
  end;
end;

procedure TFMain.MExifLensFromMakerClick(Sender: TObject);
var ETcmd:string;
begin
  if MessageDlg('This will fill Exif:LensInfo of selected files with relevant'+#10#13
               +'values from Makernotes data (where possible).'+#10#13#10#13
               +'OK to proceed?', mtInformation, [mbOK,mbCancel],0)=mrOK
  then begin
    ETcmd:='-Exif:LensInfo<LensID'+CRLF+'-Exif:LensModel<LensID';
    ET_OpenExec(ETcmd,GetSelectedFiles);
    UpdateLogWin; //ShowMessage(GetETresult);
    QuickFilelistRefresh;
    ShowMetadata;
    DeleteTmpFile;
  end;
end;

procedure TFMain.MExitClick(Sender: TObject);
begin
  Close;
end;

procedure TFMain.MExportMetaTXTClick(Sender: TObject);
var i: smallint; ETcmd,xDir:string;
 // images: string;
begin
  xDir:='';
  if GUIsettings.DefExportUse then begin
    xDir:=GUIsettings.DefExportDir;
    i:=Length(xDir); if i>0 then if xDir[i]<>'\' then xDir:=xDir+'\';
  end;

  if Sender=MExportMetaTXT then
    ETcmd:='-w'+CRLF+xDir+'%f.txt'+CRLF+'-g0'+CRLF+'-a'+CRLF+'-All:All';
  if Sender=MExportMetaMIE then
    ETcmd:='-o'+CRLF+xDir+'%f.mie'+CRLF+'-All:All';
  if Sender=MExportMetaXMP then
    ETcmd:='-o'+CRLF+xDir+'%f.xmp'+CRLF+'-Xmp:All';
  if Sender=MExportMetaEXIF then
    ETcmd:='-TagsFromFile'+CRLF+'@'+CRLF+'-All:All'+CRLF+'-o'+CRLF+'%f.exif';
  if Sender=MExportMetaHTM then
    ETcmd:='-w'+CRLF+xDir+'%f.html'+CRLF+'-htmldump';

  ET_OpenExec(ETcmd,GetSelectedFiles,true);
  UpdateLogWin; DeleteTmpFile;
  if xDir='' then BtnFListRefreshClick(Sender);
end;

procedure TFMain.MFileDateFromExifClick(Sender: TObject);
begin
  if MessageDlg('This will set "Date modified" of selected files'+#10#13
               +'according to Exif:DateTimeOriginal value.'+#10#13#10#13
               +'OK to proceed?', mtInformation,[mbOK,mbCancel],0)=mrOK
  then begin
    ET_OpenExec('-FileModifyDate<Exif:DateTimeOriginal',GetSelectedFiles);
    UpdateLogWin; DeleteTmpFile;
    with ShellList do begin  //actualize view of file DateTime
      OnClick:=nil; FullRefresh; OnClick:=ShellListClick;
    end;
    QuickFilelistRefresh;
    ShowMetadata; ShowPreview;
  end;
end;

procedure TFMain.MFileNameDateTimeClick(Sender: TObject);
begin
  FFileDateTime.ShowModal;
end;

procedure TFMain.MIgnoreErrorsClick(Sender: TObject);
begin
  with ET_Options do
    if MIgnoreErrors.Checked then ETMinorError:='-m'+CRLF
    else ET_Options.ETMinorError:='';
end;

procedure TFMain.MImportMetaSelectedClick(Sender: TObject);
var DstExt: string[7]; ETcmd:string;
    j: smallint;
begin
  //if Sender=MImportMetaIntoJPG then DstExt:='JPG' else DstExt:='TIF';
  DstExt:=UpperCase(ExtractFileExt(ShellList.SelectedFiles[0])); Delete(DstExt,1,1);
  if (DstExt='JPG') or (DstExt='TIF') then begin
    j:=ShellList.SelectedFiles.Count;
    if j>1 then //message appears only if multi files selected
    if MessageDlg('This will copy ALL metadata from any source into'+#10#13
                 +'currently *selected* '+DstExt+' files.'+#10#13
                 +'Only those selected files will be processed,'+#10#13
                 +'where source and destination filename is equal.'+#10#13#10#13
                 +'Next: Select source file. OK to proceed?', mtInformation,[mbOK,mbCancel],0)<>mrOK
    then j:=0;
    if j<>0 then begin
      with OpenPictureDlg do begin
        InitialDir:=ShellList.Path;
        Filter:='Image & Metadata files|*.*';
        Options:=[ofFileMustExist]; Title:='Select any of source files';
        FileName:='';
      end;
      if OpenPictureDlg.Execute then begin
        ETcmd:=OpenPictureDlg.FileName; // single file selected
        if j>1 then ETcmd:=ExtractFileDir(ETcmd)+'\%f'+ExtractFileExt(ETcmd); //multiple files
        ETcmd:='-TagsFromFile'+CRLF+ETcmd+CRLF+'-All:All'+CRLF;
        if FCopyMetadata.ShowModal=mrOK then begin
          with FCopyMetadata do begin
            if not CheckBox1.Checked then
              ETcmd:=ETcmd+'--exif:ExifImageWidth'+CRLF+'--exif:ExifImageHeight'+CRLF;
            if not CheckBox2.Checked then
              ETcmd:=ETcmd+'--exif:Orientation'+CRLF;
            if not CheckBox3.Checked then
              ETcmd:=ETcmd+'--exif:Xresolution'+CRLF+'--exif:Yresolution'+CRLF+'--exif:ResolutionUnit'+CRLF;
            if not CheckBox4.Checked then
              ETcmd:=ETcmd+'--exif:ColorSpace'+CRLF+'--exif:InteropIndex'+CRLF;
            if not CheckBox5.Checked then
              ETcmd:=ETcmd+'--Makernotes'+CRLF;
            if not CheckBox6.Checked then
              ETcmd:=ETcmd+'--Xmp-photoshop'+CRLF;
            if not CheckBox7.Checked then
              ETcmd:=ETcmd+'--Xmp-crs'+CRLF;
            if not CheckBox8.Checked then
              ETcmd:=ETcmd+'--Xmp-exif'+CRLF;
          end;
          ETcmd:=ETcmd+'-ext'+CRLF+DstExt;
          if ET_OpenExec(ETcmd,GetSelectedFiles,true) then begin
            UpdateLogWin;
            QuickFilelistRefresh;
            ShowMetadata;
          end;
          DeleteTmpFile;
        end;
      end;
    end;
  end else ShowMessage('Selected destination file must be JPG or TIF!');
end;

procedure TFMain.MImportMetaSingleClick(Sender: TObject);
begin
  if MessageDlg('This will copy metadata from single source file,'+#10+#13
               +'into currently selected files.'+#10+#13+#10+#13
               +'Next: 1.Select source file,  2.Select metadata to copy'+#10+#13
               +'OK to proceed?', mtInformation,[mbOK,mbCancel],0)=mrOK
  then begin
    with OpenPictureDlg do begin
      InitialDir:=ShellList.Path;
      Filter:='Image & Metadata files|*.jpg;*.jpeg;*.cr2;*.dng;*.nef;*.tif;*.tiff;*.mie;*.xmp;*.rw2';
      Options:=[ofFileMustExist]; Title:='Select source file';
      FileName:='';
    end;
    if OpenPictureDlg.Execute then begin
      FCopyMetaSingle.SrcFile:=OpenPictureDlg.FileName;
      if FCopyMetaSingle.ShowModal=mrOK then begin
        QuickFilelistRefresh;
        ShowMetadata;
      end;
    end;
  end;
end;

procedure TFMain.MImportRecursiveAllClick(Sender: TObject);
var i:integer; DstExt: string[5];
  ETcmd: string;
begin
  DstExt:=LowerCase(ExtractFileExt(ShellList.SelectedFiles[0])); Delete(DstExt,1,1);
  if (DstExt='jpg') or (DstExt='tif') then begin
    i:=MessageDlg('This will copy metadata from files in another folder'+#10#13
                 +'into *all* '+Uppercase(DstExt)+' files inside currently *selected* folder.'+#10#13
                 +'Only those files will be processed, where'+#10#13
                 +'source and destination filename is equal.'+#10#13#10#13
                 +'Should files in subfolders also be processed?', mtInformation,[mbYes,mbNo,mbCancel],0);
    if i<>mrCancel then begin
      with OpenPictureDlg do begin
          InitialDir:=ShellList.Path;
          Filter:='Image & Metadata files|*.*';
          Options:=[ofFileMustExist]; Title:='Select any of source files';
          FileName:='';
      end;
      if OpenPictureDlg.Execute then begin
        ETcmd:='-TagsFromFile'+CRLF+ExtractFilePath(OpenPictureDlg.FileName); //incl. slash
        if i=mrYes then ETcmd:=ETcmd+'%d\';
        ETcmd:=ETcmd+'%f'+ExtractFileExt(OpenPictureDlg.FileName);
        if i=mrYes then ETcmd:=ETcmd+CRLF+'-r';
        ETcmd:=ETcmd+CRLF+'-All:All'+CRLF;
        if FCopyMetadata.ShowModal=mrOK then begin
          with FCopyMetadata do begin
            if not CheckBox1.Checked then
              ETcmd:=ETcmd+'--exif:ExifImageWidth'+CRLF+'--exif:ExifImageHeight'+CRLF;
            if not CheckBox2.Checked then
              ETcmd:=ETcmd+'--exif:Orientation'+CRLF;
            if not CheckBox3.Checked then
              ETcmd:=ETcmd+'--exif:Xresolution'+CRLF+'--exif:Yresolution'+CRLF+'--exif:ResolutionUnit'+CRLF;
            if not CheckBox4.Checked then
              ETcmd:=ETcmd+'--exif:ColorSpace'+CRLF+'--exif:InteropIndex'+CRLF;
            if not CheckBox5.Checked then
              ETcmd:=ETcmd+'--Makernotes'+CRLF;
            if not CheckBox6.Checked then
              ETcmd:=ETcmd+'--Xmp-photoshop'+CRLF;
            if not CheckBox7.Checked then
              ETcmd:=ETcmd+'--Xmp-crs'+CRLF;
            if not CheckBox8.Checked then
              ETcmd:=ETcmd+'--Xmp-exif'+CRLF;
          end;
          ETcmd:=ETcmd+'-ext'+CRLF+DstExt;
          ETCounter:=GetNrOfFiles(ShellList.path,'*.'+DstExt,(i=mrYes));
          if ET_OpenExec(ETcmd,'.',true) then begin
            UpdateLogWin;
            QuickFilelistRefresh;
            ShowMetadata;
          end;
        end;
      end;
    end;
  end else ShowMessage('Selected destination file must be JPG or TIF!');
end;

procedure TFMain.MImportXMPLogClick(Sender: TObject);
var SrcDir,ETcmd: string;
begin
  if MessageDlg('This will import GPS data from XMP sidecar files into'+#10#13
               +'Exif GPS region of currently selected files.'+#10#13
               +'Only those selected files will be processed, where'+#10#13
               +'source and destination filename is equal.'+#10#13#10#13
               +'Next: Select folder containing XMP files. OK to proceed?', mtInformation,[mbOK,mbCancel],0)=mrOK
  then begin
    if GpsXmpDir<>'' then SrcDir:=GpsXmpDir else SrcDir:=ShellList.Path;
    SrcDir:=BrowseFolderDlg('Choose folder containing XMP sidecar files',1,SrcDir);
    if SrcDir<>'' then begin
      if SrcDir[Length(SrcDir)]<>'\' then SrcDir:=SrcDir+'\';
      GpsXmpDir:=SrcDir;
      ETcmd:='-TagsFromFile'+CRLF+SrcDir+'%f.xmp'+CRLF;
      ETcmd:=ETcmd+'-GPS:GPSLatitude<Xmp-exif:GPSLatitude'+CRLF
                  +'-GPS:GPSLongitude<Xmp-exif:GPSLongitude'+CRLF;
      ETcmd:=ETcmd+'-GPS:GPSLatitudeRef<Composite:GPSLatitudeRef'+CRLF
                  +'-GPS:GPSLongitudeRef<Composite:GPSLongitudeRef'+CRLF;
      ETcmd:=ETcmd+'-GPS:GPSDateStamp<XMP-exif:GPSDateTime'+CRLF
                  +'-GPS:GPSTimeStamp<XMP-exif:GPSDateTime';
      if ET_OpenExec(ETcmd,GetSelectedFiles,true) then begin
        UpdateLogWin;
        QuickFilelistRefresh;
        ShowMetadata;
      end;
      DeleteTmpFile;
    end;
  end;
end;

procedure TFMain.MJPGAutorotateClick(Sender: TObject);
var img:string; i,j: smallint;
begin
  if MessageDlg('This will rotate selected JPG files according to'+#10#13
               +'existing Exif:Orientation value.'+#10#13
               +'In case menu Preserve Date modified is checked,'+#10#13
               +'Exif DateTime values (on ALL selected files) will'+#10#13
               +'be used for this purpose.'+#10#13#10#13
               +'OK to proceed?', mtInformation,[mbOK,mbCancel],0)=mrOK
  then begin
    img:=''; j:=ShellList.SelectedFiles.Count-1;
    i:=ShellList.Items.Count;
    if i=(j+1) then img:=' '+ShellList.Filter //all files selected
    else for i:=0 to j do img:=img+' "'+ShellList.SelectedFiles[i]+'"';
    if MPreserveDateMod.Checked then img:=' -ft'+img;
    // ^ sets win DateModified as in Exif:DateTimeOriginal>ModifyDate>CreateDate
    if ExecCMD('jhead -autorot -q'+img,ShellList.Path) then
      ShowMessage('Autorotate finished.')
    else ShowMessage('Missing jhead.exe && jpegtran.exe!');
    // ShowMetadata; ShowPreview; ShellListMetaRefresh;
    // ^ ShellList is refreshed by windows -> file(s) get deselected
  end;
end;

procedure TFMain.MJPGfromCR2Click(Sender: TObject);
var b:word; ETcmd: string;
begin
  b:=MessageDlg('Create JPG files in subfolder?',mtConfirmation,mbYesNoCancel,0);
  if b<>mrCancel then begin
    ETcmd:='-w'+CRLF;
    if b=mrYes then ETcmd:=ETcmd+'preview\';
    if b=mrYes then ETcmd:=ETcmd+'%f.jpg' else ETcmd:=ETcmd+'%f_%e.jpg';
    ETcmd:=ETcmd+CRLF+'-b'+CRLF;
    if Sender=MJPGfromCR2 then ETcmd:=ETcmd+'-PreviewImage'+CRLF+'-ext'+CRLF+'CR2'+CRLF+'-ext'+CRLF+'DNG';
    if Sender=MJPGfromNEF then ETcmd:=ETcmd+'-JpgFromRaw'+CRLF+'-ext'+CRLF+'NEF'+CRLF+'-ext'+CRLF+'NRW';
    if Sender=MJPGfromRW2 then ETcmd:=ETcmd+'-JpgFromRaw'+CRLF+'-ext'+CRLF+'RW2'+CRLF+'-ext'+CRLF+'PEF';
    if ET_OpenExec(ETcmd,GetSelectedFiles) then
      UpdateLogWin;
    ShellTree.SmartRefresh;
    DeleteTmpFile;
  end;
end;

procedure TFMain.MJPGtoCR2Click(Sender: TObject);
var i,j:smallint; n,W,H,c:word;
    dirJPG,img,tx,err:string;
begin
  n:=MessageDlg('Only those JPG images will be embedded into selected'#10#13
               +'CR2 files, where:'+#10#13
               +'- CR2/JPG filenames are equal,'+#10#13
               +'- JPG width or height is min 512pix,'+#10#13
               +'- JPG width & height is multiple of 8.'+#10#13
               +'Metadata of imported JPG files will be deleted.'+#10#13#10#13
               +'Next: Select folder containing JPG files. OK to proceed?', mtInformation,[mbOK,mbCancel],0);
  j:=ShellList.SelectedFiles.Count;
  if (n=mrOK) and (j>0) then begin
    dirJPG:=BrowseFolderDlg('Select folder containing JPG images',1,ShellList.Path);
    if dirJPG<>'' then begin
      if dirJPG[Length(dirJPG)]<>'\' then dirJPG:=dirJPG+'\';
      LabelCounter.Visible:=true; c:=0; err:='';
      for i:=0 to j-1 do begin
        LabelCounter.Caption:=IntToStr(j-i);
        img:=ShellList.SelectedFiles.Strings[i];
        tx:=ExtractFileExt(img);
        if UpperCase(tx)='.CR2' then begin
          n:=pos(tx,img);   //get file extension position
          SetLength(img,n); //filename ending with dot (without extension)
          if FileExists(dirJPG+img+'jpg') then begin

            ET_OpenExec('-s3'+CRLF+'-ImageSize',dirJPG+img+'jpg');
            tx:=ETout[0]; n:=pos('x',tx); SetLength(tx,n-1);
            W:=StrToIntDef(tx,0); tx:=ETout[0]; Delete(tx,1,n);
            H:=StrToIntDef(tx,0);
            if H>W then begin //jpg is portrait
              n:=W; W:=H; H:=n;
              ET_OpenExec('-s3'+CRLF+'-exif:Orientation#',img+'cr2');
              n:=StrToIntDef(ETout[0],1);
            end else n:=1;

            if (W>=512) and ((W mod 8)=0) and ((H mod 8)=0) then begin
              ET_OpenExec('-m'+CRLF+'-All=',dirJPG+img+'jpg');
              case n of
                6: tx:='jpegtran -rotate 270 ';
                8: tx:='jpegtran -rotate 90 ';
              end;
              if n<>1 then ExecCMD(tx+img+'jpg '+img+'jpg', dirJPG);
              tx:='-PreviewImage<='+dirJPG+'%f.jpg';
              tx:=tx+CRLF+'-IFD0:ImageWidth='+IntToStr(W);
              tx:=tx+CRLF+'-IFD0:ImageHeight='+IntToStr(H);
              ET_OpenExec(tx,img+'cr2');
              inc(c);
            end else err:=err+img+'JPG -invalid size'+CRLF
          end else err:=err+img+'JPG -not found'+CRLF;
        end;
      end;
      LabelCounter.Visible:=false;
      StatusBar.Panels[1].Text:=IntToStr(c)+' of '+IntToStr(j)+' files updated.';
      if Length(err)>0 then begin
        err:=err+'<-END-';
        FLogWin.MemoLog.Text:=err;
        FLogWin.Show;
      end;
    end;
  end;
end;

procedure TFMain.MImportGPSLogClick(Sender: TObject);
begin
  if FGeotag.ShowModal=mrOK then begin
    QuickFilelistRefresh;
    ShowMetadata;
  end;
end;

procedure TFMain.MPreferencesClick(Sender: TObject);
begin
  if FPreferences.ShowModal=mrOK then begin
    ShowMetadata;
  end;
end;

procedure TFMain.MPreserveDateModClick(Sender: TObject);
begin
  with ET_Options do
    if MPreserveDateMod.Checked then ETFileDate:='-P'+CRLF
    else ETFileDate:='';
end;

procedure TFMain.MQuickManagerClick(Sender: TObject);
var i:smallint;
begin
  if FQuickManager.ShowModal=mrOK then begin
    i:=FQuickManager.StringGrid1.Row;
    if SpeedBtnQuick.Down then begin
      ShowMetadata;
      if ShellList.ItemIndex>=0 then MetadataList.Row:=i+1;
    end;
  end;
end;

procedure TFMain.MRemoveMetaClick(Sender: TObject);
begin
  if FRemoveMeta.ShowModal=mrOK then ShowMetadata;
end;

procedure TFMain.MShowNumbersClick(Sender: TObject);
begin
  if Sender=MShowNumbers then with ET_Options do
    if MShowNumbers.Checked then ETShowNumber:='-n'+CRLF else ETShowNumber:='';
  if Sender=MShowGPSdecimal then with ET_Options do
    if MShowGPSdecimal.Checked then ETGPSformat:='-c'+CRLF+'%.6f'+CRLF
                               else ETGPSformat:='-c'+CRLF+'%d%.4f'+CRLF;
  //+ used by MShowHexID, MGroup_g4, MShowComposite, MShowSorted, MNotDuplicated
  QuickFilelistRefresh;
  ShowMetadata;
end;

procedure TFMain.MWorkspaceLoadClick(Sender: TObject);
begin
  with OpenFileDlg do begin
    //DefaultExt:='ini';
    InitialDir:=WrkIniDir;
    Filter:='Ini file|*.ini';
    Title:='Load Workspace definition file';
    if Execute then begin
      if LoadWorkspaceIni(FileName) then begin
        if SpeedBtnQuick.Down then ShowMetadata else ShowMessage('New Workspace loaded.');
      end else ShowMessage('Ini file doesn''t contain Workspace data -nothing changed.');
      WrkIniDir:=ExtractFileDir(FileName);
    end;
  end;
end;

procedure TFMain.MWorkspaceSaveClick(Sender: TObject);
var DoSave,IsOK: boolean;
begin
  with SaveFileDlg do begin
    DefaultExt:='ini';
    InitialDir:=WrkIniDir;
    Filter:='Ini file|*.ini';
    Title:='Save Worspace definition file';
    repeat
      IsOK:=false; DoSave:=Execute;
      InitialDir:=ExtractFileDir(FileName);
      if DoSave then begin
        IsOK:=(ExtractFileName(FileName)<>'ExifToolGUIv5.ini');
        if not IsOK then ShowMessage('Use another name for Workspace definition file!');
      end;
    until not DoSave or IsOK;
    if DoSave then begin
      if SaveWorkspaceIni(FileName) then ShowMessage('Workspace definition file saved.')
      else ShowMessage('Workspace definition file couldn''t be saved!?');
      WrkIniDir:=ExtractFileDir(FileName);
    end;
  end;
end;

procedure TFMain.QuickPopUpMenuPopup(Sender: TObject);
var i:smallint; IsSep,Other:boolean;
    tx:string;
begin
  i:=MetadataList.Row;
  tx:=MetadataList.Keys[i];
  QuickPopUp_UndoEdit.Visible:=(pos('*',tx)=1);
  IsSep:=(Length(tx)=0);

  QuickPopUp_AddQuick.Visible:=not IsSep and (SpeedBtnExif.Down or SpeedBtnXmp.Down or SpeedBtnIptc.Down);
  QuickPopUp_AddCustom.Visible:=not(SpeedBtnQuick.Down or SpeedBtnCustom.Down or IsSep);
  QuickPopUp_DelCustom.Visible:=SpeedBtnCustom.Down and not(IsSep);
  QuickPopUp_AddDetailsUser.Visible:=not IsSep and (SpeedBtnExif.Down or SpeedBtnXmp.Down or SpeedBtnIptc.Down);

  Other:=(GUIsettings.Language<>'') or IsSep;

  QuickPopUp_MarkTag.Visible:=not(SpeedBtnQuick.Down or SpeedBtnCustom.Down or Other);

  //QuickPopUp_AddCustom.Visible:=not(SpeedBtnQuick.Down or SpeedBtnCustom.Down or Other);
  //QuickPopUp_DelCustom.Visible:=SpeedBtnCustom.Down and not(Other);

  (*
  Other:=Other or SpeedBtnQuick.Down or SpeedBtnMaker.Down
               or SpeedBtnAll.Down or SpeedBtnCustom.Down;
  *)
  //QuickPopUp_AddQuick.Visible:=not(Other);
  QuickPopUp_DelQuick.Visible:=not(IsSep) and SpeedBtnQuick.Down;
  QuickPopUp_FillQuick.Visible:=QuickPopUp_DelQuick.Visible;
  //QuickPopUp_AddDetailsUser.Visible:=not(Other);
  QuickPopUp_CopyTag.Visible:=not IsSep;
end;

function TFMain.TranslateTagName(xMeta,xName:string):string;
var i:integer; //xMeta~'-Exif:' or '-IFD0:' or ...
begin
  if ET_Options.ETLangDef<>'' then begin
    ET_OpenExec('-X'+CRLF+'-l'+CRLF+xMeta+'All',ShellList.SelectedFiles[0]);
    i:=ETout.Count;
    while i>1 do begin
      dec(i); if pos('desc>'+xName+'</et:',ETout[i])>0 then break;
    end;
    dec(i);
    if i>=0 then begin
      xName:=ETout[i];
      i:=pos(':',xName); Delete(xName,1,i);
      i:=pos(' ',xName); SetLength(xName,i-1);
    end;
    ETout.Clear; ETerr.Clear;
  end;
  result:=xName;
end;

procedure TFMain.QuickPopUp_AddCustomClick(Sender: TObject);
var i:smallint; tx,ts:string; IsVRD: boolean;
begin
  (*
  with MetadataList do tx:=Keys[Row];
  if LeftStr(tx,2)='0x' then Delete(tx,1,7)
    else if LeftStr(tx,2)='- ' then Delete(tx,1,2);
  tx:=TrimRight(tx);
  if SpeedBtnExif.Down then tx:='-Exif:'+tx
   else if SpeedBtnIptc.Down then tx:='-IPTC:'+tx
    else if SpeedBtnXmp.Down then tx:='-XMP:'+tx
     else if SpeedBtnMaker.Down then begin
       i:=MetadataList.Row;
       repeat
         isVRD:=(Pos('CanonVRD',MetadataList.Cells[1,i])>0); dec(i);
       until IsVRD or (i<0);
       if IsVRD then tx:='-CanonVRD:'+tx else tx:='-Makernotes:'+tx;
     end
      else tx:='-'+tx;
  *)
  i:=MetadataList.Row; tx:=MetadataList.Keys[i];
  if LeftStr(tx,2)='0x' then Delete(tx,1,7)
    else if LeftStr(tx,2)='- ' then Delete(tx,1,2);
  tx:=TrimRight(tx);
  if SpeedBtnExif.Down then ts:='-Exif:'
    else if SpeedBtnXmp.Down then ts:='-Xmp:'
      else if SpeedBtnIptc.Down then ts:='-Iptc:'
        else if SpeedBtnMaker.Down then begin
          repeat
            dec(i);
            isVRD:=(Pos('CanonVRD',MetadataList.Cells[1,i])>0);
          until IsVRD or (i=0);
          if IsVRD then ts:='-CanonVRD:' else ts:='-Makernotes:';
        end
          else ts:='-';
  (*
  if ET_Options.ETLangDef<>'' then begin
    ET_OpenExec('-X'+CRLF+'-l'+CRLF+ts+'All',ShellList.SelectedFiles[0]);
    i:=ETout.Count;
    while i>1 do begin
      dec(i); if pos('desc>'+tx+'</et:',ETout[i])>0 then break;
    end;
    dec(i);
    if i>=0 then begin
      tx:=ETout[i];
      i:=pos(':',tx); Delete(tx,1,i);
      i:=pos(' ',tx); SetLength(tx,i-1);
    end;
    ETout.Clear; ETerr.Clear;
  end;
  tx:=ts+tx;
  *)
  tx:=ts+TranslateTagName(ts,tx);
  if pos(tx,CustomViewTags)>0 then ShowMessage('Tag allready exist in Custom view.')
  else CustomViewTags:=CustomViewTags+tx+' ';
end;

procedure TFMain.QuickPopUp_AddDetailsUserClick(Sender: TObject);
var i,n,x:smallint;
  tx,tk:string;
begin
  i:=Length(FListColUsr); SetLength(FListColUsr,i+1);
  n:=MetadataList.Row; x:=n;
  repeat //find group
    dec(x); tx:=MetadataList.Keys[x];
  until Length(tx)=0;
  tx:=MetadataList.Cells[1,x]; //eg '---- IFD0 ----'
  Delete(tx,1,5);     //='IFD0 ----'
  x:=pos(' ',tx);
  SetLength(tx,x-1);  //='IFD0'
  tx:='-'+tx+':';     //='-IFD0:'

  tk:=MetadataList.Keys[n]; //'Make'
  if LeftStr(tk,2)='0x' then Delete(tk,1,7)
    else if LeftStr(tk,2)='- ' then Delete(tk,1,2);
  tk:=TrimRight(tk);

  FListColUsr[i].Caption:=tk;
  tk:=TranslateTagName(tx,tk);
  FListColUsr[i].Command:=tx+tk; //='-IFD0:Make'
  FListColUsr[i].Width:=96;
  FListColUsr[i].AlignR:=0;

  with CBoxDetails do begin i:=ItemIndex; n:=Items.Count-1; end;
  if i=n then with ShellList do begin
    OnClick:=nil;
    FullRefresh;
    //SetFocus;
    OnClick:=ShellListClick;
    ShowMetadata;
  end;
end;

procedure TFMain.QuickPopUp_AddQuickClick(Sender: TObject);
var i,n,x:smallint;
  tx,ty,tz,tl:string;
begin
  i:=Length(QuickTags); SetLength(QuickTags,i+1);
  n:=MetadataList.Row;
  if SpeedBtnExif.Down then tz:='Exif:'
  else if SpeedBtnXmp.Down then tz:='Xmp:'
  else if SpeedBtnIptc.Down then tz:='Iptc:' else tz:='';

  if MGroup_g4.Checked then tx:=tz
  else begin //find group
    x:=n;
    repeat dec(x); tx:=MetadataList.Keys[x]; until Length(tx)=0;
    tx:=MetadataList.Cells[1,x]; //eg '---- IFD0 ----'
    Delete(tx,1,5);     //-> 'IFD0 ----'
    x:=pos(' ',tx);
    SetLength(tx,x-1);  //-> 'IFD0'
    tx:=tx+':';         //-> 'IFD0:'
  end;


  ty:=MetadataList.Keys[n]; //e.g. 'Make' or '0x010f Make' or '- Rating'
  //x:=pos(' ',ty); if x>0 then Delete(ty,1,x); //get tag name only
  if LeftStr(ty,2)='0x' then Delete(ty,1,7)
    else if LeftStr(ty,2)='- ' then Delete(ty,1,2);
  ty:=TrimRight(ty);
  tl:=ty; //tl=language specific tag name
  (*
  if ET_Options.ETLangDef<>'' then begin
    ET_OpenExec('-X'+CRLF+'-l'+CRLF+'-'+tz+'All',ShellList.SelectedFiles[0]);
    n:=ETout.Count;
    while n>1 do begin
      dec(n); if pos('desc>'+ty+'</et:',ETout[n])>0 then break;
    end;
    dec(n);
    if n>=0 then begin
      ty:=ETout[n];
      x:=pos(':',ty); Delete(ty,1,x);
      x:=pos(' ',ty); SetLength(ty,x-1); // ty:=LeftStr(ty,x-1);
    end;
    ETout.Clear; ETerr.Clear;
  end;
  *)
  ty:=TranslateTagName('-'+tz,ty);
  with QuickTags[i] do begin
    Caption:=tz+tl;
    Command:='-'+tx+ty; //='-IFD0:Make'
    Help:='No Hint defined';
  end;
end;

procedure TFMain.QuickPopUp_DelCustomClick(Sender: TObject);
var i,j:smallint; tx,tl: string;
begin
  i:=MetadataList.Row;
  if ET_Options.ETLangDef<>'' then begin
    tl:=ET_Options.ETLangDef;
    ET_Options.ETLangDef:='';
    ShowMetadata;
    tx:=MetadataList.Keys[i];
    ET_Options.ETLangDef:=tl;
  end else tx:=MetadataList.Keys[i];

  if LeftStr(tx,2)='0x' then Delete(tx,1,7)
    else if LeftStr(tx,2)='- ' then Delete(tx,1,2);
  tx:=TrimRight(tx); //=tag name

  if Length(tx)>0 then begin //should be always true!
    i:=pos(tx,CustomViewTags); j:=i;
    repeat dec(i); until CustomViewTags[i]='-';
    repeat inc(j); until CustomViewTags[j]=' ';
    Delete(CustomViewTags,i,j-i+1);
    if Length(CustomViewTags)=0 then CustomViewTags:='-Exif:Artist ';
  end;
  ShowMetadata;
end;

procedure TFMain.QuickPopUp_DelQuickClick(Sender: TObject);
var i,n:smallint;
begin
  n:=MetadataList.Row-1; i:=Length(QuickTags)-1;
  while n<i do begin
    QuickTags[n].Caption:=QuickTags[n+1].Caption;
    QuickTags[n].Command:=QuickTags[n+1].Command;
    QuickTags[n].Help:=QuickTags[n+1].Help;
    QuickTags[n].NoEdit:=QuickTags[n+1].NoEdit;
    inc(n);
  end;
  SetLength(QuickTags,i);
  ShowMetadata;
end;

procedure TFMain.QuickPopUp_FillQuickClick(Sender: TObject);
var i,n: smallint; tx:string;
begin
  n:=Length(QuickTags);
  with MetadataList do begin
    for i:=0 to n-1 do begin
      tx:=QuickTags[i].Caption;
      if RightStr(tx,1)='*' then begin
        Insert('*',tx,1);
        Keys[i+1]:=tx;
        Cells[1,i+1]:=QuickTags[i].Help;
      end;
    end;
    SpeedBtnQuickSave.Enabled:=true;
  end;
end;

procedure TFMain.QuickPopUp_MarkTagClick(Sender: TObject);
var i,j:smallint; tx:string;
begin
  with MetadataList do tx:=Keys[Row];
  i:=pos(' ',tx); if i>0 then Delete(tx,1,i); //if Show HexID exist
  if Length(tx)>0 then begin
    i:=pos(tx,MarkedTags);
    if i>0 then begin //tag allready marked: unmark it
      j:=i;
      repeat inc(j); until MarkedTags[j]=' ';
      Delete(MarkedTags,i,j-i+1);
      if Length(MarkedTags)=0 then MarkedTags:='Artist ';
    end else MarkedTags:=MarkedTags+tx+' '; //mark tag
    //ShowMetadata; // -updates automatically
  end;
end;

procedure TFMain.QuickPopUp_UndoEditClick(Sender: TObject);
var i,n,x:smallint; tx:string;
begin
  i:=MetadataList.Row;
  MetadataList.Keys[i]:=QuickTags[i-1].Caption;
  tx:='-s3'+CRLF+'-f'+CRLF+QuickTags[i-1].Command;
  ET_OpenExec(tx,ShellList.SelectedFiles[0]);
  if ETout.Count>0 then MetadataList.Cells[1,i]:=ETout[0];
  n:=MetadataList.RowCount-1; x:=0;
  for i:=1 to n do if pos('*',MetadataList.Keys[i])=1 then inc(x);
  SpeedBtnQuickSave.Enabled:=(x>0);
end;

procedure TFMain.DeleteTmpFile;
begin
  if TmpFileUsed then DeleteFile('ExifToolGUI.tmp');
end;

procedure TFMain.UpdateLogWin;
var i,n:smallint;
begin
  with FLogWin do begin
    MemoLog.Lines:=ETout;
    i:=ETout.Count; if i>0 then StatusBar.Panels[1].Text:=ETout[i-1];
    i:=ETerr.Count;
    if i>0 then begin
      dec(i);
      for n:=0 to i do MemoLog.Lines.Append(ETerr[n]);
      Show; //WindowState:=wsNormal;
    end;
    MemoLog.Lines.Append('<-END-');
  end;
  ETout.Clear; ETerr.Clear;
end;

procedure TFMain.UpdateStatusBar_FilesShown;
var i:smallint;
begin
  i:=ShellList.Items.Count;
  StatusBar.Panels[0].Text:='Files: '+IntToStr(i);
end;

procedure TFMain.EditETcmdNameChange(Sender: TObject);
begin
  if (EditETdirect.Text<>'') and (EditETcmdName.Text<>'') then begin
    SpeedBtnETdirectReplace.Enabled:=(CBoxETdirect.ItemIndex>=0);
    SpeedBtnETdirectAdd.Enabled:=EditETdirect.Modified;
  end else begin
    SpeedBtnETdirectReplace.Enabled:=false;
    SpeedBtnETdirectAdd.Enabled:=false;
  end;
end;

procedure TFMain.EditETdirectChange(Sender: TObject);
begin
  if (EditETdirect.Text<>'') and (EditETcmdName.Text<>'') then begin
    SpeedBtnETdirectReplace.Enabled:=(CBoxETdirect.ItemIndex>=0);
    SpeedBtnETdirectAdd.Enabled:=EditETcmdName.Modified;
  end else begin
    SpeedBtnETdirectReplace.Enabled:=false;
    SpeedBtnETdirectAdd.Enabled:=false;
  end;
end;

(*
procedure TFMain.EditETdirectKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  IsUtf8,IsRecursive,IsRename: boolean;
  i: smallint;
  ETprm: AnsiString;
begin
  ETprm:=Trim(EditETdirect.Text);
  if (Key=VK_RETURN) and (Length(ETprm)>1) then begin
    if LowerCase(LeftStr(ETprm,9))='exiftool ' then Delete(ETprm,1,9);

    IsUtf8:=(pos('-L ',ETprm)=0);
    IsRecursive:=(pos('-r ',ETprm)>0);
    IsRename:=(pos('-filename=',ETprm)>0);
    if IsRecursive then begin //init ETcounter:
      ETprm:=ETprm+' "'+ExtractFileDir(ShellList.path)+'"';
      i:=pos('-ext ',ETprm);   //ie. '-ext jpg ...'
      if i=0 then ETprm:='*.*' else begin
        inc(i,4); Delete(ETprm,1,i);
        ETprm:=TrimLeft(ETprm); //='jpg ...'
        i:=pos(' ',ETprm); if i>0 then ETprm:=LeftStr(ETprm,i-1);
        ETprm:='*.'+ETprm;
      end;
      ETcounter:=GetNrOfFiles(ShellList.path,ETprm,true);
    end;
    if ExecET(ETprm,GetSelectedFiles(false), ShellList.Path, IsUtf8) then begin
      UpdateLogWin; //do 1st: to get result (ETout/ETerr) of operation
      if IsRename then ShellList.FullRefresh else QuickFilelistRefresh;
      ShowMetadata;
    end else ShowMessage('ExifTool not executed!?');
    ETprm:='';
    ShowPreview; DeleteTmpFile;
  end;
end;
*)
procedure TFMain.EditETdirectKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  IsUtf8,IsRecursive: boolean;
  i: smallint;
  ETtx: string;
  ETprm: AnsiString;
begin
  ETtx:=EditETdirect.Text;
  if (Key=VK_RETURN) and (Length(ETtx)>1) then begin
    IsRecursive:=(pos('-r ',ETtx)>0);
    IsUtf8:=(pos('-L ',ETtx)=0);
    if IsUtf8 then ETprm:=Utf8Encode(ETtx) else ETprm:=ETtx;
    if IsRecursive then begin //init ETcounter:
      ETprm:=ETprm+' "'+ExtractFileDir(ShellList.path)+'"';
      i:=pos('-ext ',ETtx);   //ie. '-ext jpg ...'
      if i=0 then ETtx:='*.*' else begin
        inc(i,4); Delete(ETtx,1,i);
        ETtx:=TrimLeft(ETtx); //='jpg ...'
        i:=pos(' ',ETtx); if i>0 then ETtx:=LeftStr(ETtx,i-1);
        ETtx:='*.'+ETtx;
      end;
      ETcounter:=GetNrOfFiles(ShellList.path,ETtx,true);
    end; // else ETprm:=ETprm+GetSelectedFiles(false);
    if ExecET(ETprm, GetSelectedFiles(false), ShellList.Path, IsUtf8) then begin
      UpdateLogWin; //do 1st: to get result (ETout/ETerr) of operation
      QuickFilelistRefresh;
      ShowMetadata;
    end else ShowMessage('ExifTool not executed!?');
    ETprm:='';
    ShowPreview; DeleteTmpFile;
  end;
end;


procedure TFMain.EditQuickEnter(Sender: TObject);
begin
  with MetadataList do begin
    if Sender=EditQuick then begin
      if QuickTags[Row-1].NoEdit then EditQuick.Color:=$9090FF
                                 else EditQuick.Color:=$BBFFFF;
    end else begin
      if QuickTags[Row-1].NoEdit then MemoQuick.Color:=$9090FF
                                 else MemoQuick.Color:=$BBFFFF;
      MemoQuick.SelectAll;
    end;
    StatusBar.Panels[2].Text:=QuickTags[Row-1].Help;
  end;
end;

procedure TFMain.EditQuickExit(Sender: TObject);
begin
  if Sender=EditQuick then EditQuick.Color:=clWindow
                      else MemoQuick.Color:=clWindow;
  StatusBar.Panels[2].Text:='';
end;

procedure TFMain.EditQuickKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var i: smallint; tx: string;
begin
  i:=MetadataList.Row;
  if (Key=VK_RETURN) and not(QuickTags[i-1].NoEdit) then with MetadataList do begin
    if Sender=EditQuick then tx:=Trim(EditQuick.Text) //delete leading and trailing spaces
                        else tx:=Trim(MemoQuick.Text);
    Cells[1,i]:=tx;
    tx:=Keys[i]; if tx[1]<>'*' then Keys[i]:='*'+tx; //mark tag value changed
    //if i<RowCount-1 then Row:=i+1;                   //select next row
    if GUIsettings.AutoIncLine and (i<RowCount-1) then Row:=i+1; //select next row
    Refresh; SetFocus;
    SpeedBtnQuickSave.Enabled:=true;
    //AdvPageFilelist.Enabled:=false;
    //AdvPageBrowse.Enabled:=false;
  end;

  if Key=VK_ESCAPE then with MetadataList do begin
    if Sender=EditQuick then begin
      if QuickTags[i-1].NoEdit then EditQuick.Text:=''
      else begin
        if RightStr(Keys[i],1)=#177 then EditQuick.Text:='+'
                                    else EditQuick.Text:=Cells[1,i];
      end;
    end else begin
      if QuickTags[i-1].NoEdit then MemoQuick.Text:=''
      else begin
        if RightStr(Keys[i],1)=#177 then MemoQuick.Text:='+'
                                    else MemoQuick.Text:=Cells[1,i];
      end;
    end;
    SetFocus;
  end;
end;

procedure TFMain.ShowPreview;
var w,h:integer; fPath:string;
    fExt:string[7];
begin
  if ShellList.SelCount>0 then begin // if ShellList.SelCount=1 then begin
    with ShellList do fPath:=GetFullPath(ItemIndex);
    fExt:=LowerCase(ExtractFileExt(fPath));
    w:=RotateImg.Width; h:=RotateImg.Height;
    if GUIsettings.AutoRotatePreview and ((fExt='.jpg') or (fExt='.jpeg')) then begin
      RotateImg.Tag:=GetOrientationValue(fPath);
      with RotateImg do begin
        Case Tag of
        0,1: Angle:=0; //no tag or don't rotate
          3: Angle:=180;
          6: begin Angle:=-90; w:=Height; h:=Width; end; //-90;
          8: begin Angle:=90;  w:=Height; h:=Width; end;//-270;
        end;
      end;
    end else RotateImg.Angle:=0;
    ShellBrowser.ObjectName:=fPath;
    RotateImg.Picture.Bitmap:=ShellBrowser.GetThumbnailBitmap(w,h);
    AdvTabPreview.Refresh;
  end else RotateImg.Picture.Bitmap.Handle:=0;
end;

procedure TFMain.CBoxDetailsDropDown(Sender: TObject);
var i,n:smallint;
begin //remember ColWidths in case DetailsView will be changed
  i:=CBoxDetails.ItemIndex;

  with ShellList do begin
    case i of
    0: for n:=0 to 3 do FListStdColWidth[n]:=Column[n].Width;
    1: for n:=0 to high(FListColDef1) do FListColDef1[n].Width:=Column[n+1].Width;
    2: for n:=0 to high(FListColDef2) do FListColDef2[n].Width:=Column[n+1].Width;
    3: for n:=0 to high(FListColDef3) do FListColDef3[n].Width:=Column[n+1].Width;
    else for n:=0 to High(FListColUsr) do FListColUsr[n].Width:=Column[n+1].Width;
    end;
  end;

end;

procedure TFMain.CBoxETdirectChange(Sender: TObject);
var i:smallint;
begin
  i:=CBoxETdirect.ItemIndex;
  if i>=0 then begin
    EditETdirect.Text:=ETdirectCmd[i]; EditETdirect.Modified:=false;
    EditETcmdName.Text:=CBoxETdirect.Text; EditETcmdName.Modified:=false;
    SpeedBtnETdirectDel.Enabled:=true; //Delete
  end else SpeedBtnETdirectDel.Enabled:=false;
  SpeedBtnETdirectReplace.Enabled:=false;
  SpeedBtnEtdirectAdd.Enabled:=false;
  EditETdirect.SetFocus;
end;

procedure TFMain.CBoxFileFilterChange(Sender: TObject);
var i: smallint;
begin
  i:=CBoxFileFilter.ItemIndex;
  if i>=0 then begin
    SpeedBtnFilterEdit.Enabled:=(i<>0);
    if i=0 then ShellList.Filter:='*.*'
           else ShellList.Filter:=CBoxFileFilter.Items[i];
    ShellList.SetFocus;
  end;
end;

procedure TFMain.CBoxFileFilterKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var i:smallint; tx:string;
begin
  if Key=VK_RETURN then begin
    tx:=Trim(CBoxFileFilter.Text); CBoxFileFilter.Text:=tx;
    i:=Pos('.',tx);
    if (i>1) and (i<Length(tx)) then begin
      ShellList.Filter:=tx;
      ShellList.SetFocus;
    end;
  end;
end;

procedure TFMain.FormCanResize(Sender: TObject; var NewWidth,
  NewHeight: Integer; var Resize: Boolean);
var n,x: integer;
begin
  if WindowState<>wsMinimized then begin
    n:=GUIBorderWidth+AdvPanelBrowse.Width+AdvPageMetadata.Width+Splitter1.Width;
    x:=n+Splitter2.MinSize+Splitter2.Width;
    if NewWidth<x then Resize:=false;

    x:=GUIBorderHeight+AdvPagePreview.Height+StatusBar.Height;
    if NewHeight<x+128 then Resize:=false;

    if Resize then begin
      with StatusBar do Panels[1].Width:=NewWidth-n;
    end;
  end;

end;

procedure TFMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  //if WindowState=wsMaximized then ShowMessage('Is Maximized!');
  ShellList.ViewStyle:=vsReport; //-otherwise exception when INIsaved
  if not SaveGUIini then ShowMessage('Cannot save GUI settings');
end;

procedure TFMain.FormCreate(Sender: TObject);
begin
  //---for Drag_Drop file:
  originalPanelWindowProc:=AdvTabPreview.WindowProc;
  AdvTabPreview.WindowProc:=PanelWindowProc;
  DragAcceptFiles(AdvTabPreview.Handle,true);
end;
//---------------Drag_Drop procs --------------------
procedure TFMain.PanelWindowProc(var Msg:TMessage);
begin
  if Msg.Msg=WM_DROPFILES then PanelImageDrop(TWMDROPFILES(Msg))
                          else originalPanelWindowProc(Msg);
 end;

procedure TFMain.PanelImageDrop(var Msg:TWMDROPFILES);
var
  numFiles: LongInt;
  buffer: array[0..MAX_PATH] of char;
  fName: string;
begin
  numFiles:=DragQueryFile(Msg.Drop, $FFFFFFFF, nil, 0);
  if numFiles>1 then ShowMessage('Drop only one file at a time!')
  else begin
    DragQueryFile(Msg.Drop, 0, @buffer, sizeof(buffer));

    ShellTree.SelectedFolder:=ExtractFileDir(buffer);
    fName:=ExtractFileName(buffer);
    with ShellList do begin
      ItemIndex:=-1; numFiles:=Items.Count;
      while numFiles>0 do begin
        if ExtractFileName(Items[numFiles-1].FullPath)=fName then break;
        dec(numFiles);
      end;
      ItemIndex:=numFiles-1;
    end;
    ShowPreview; ShowMetadata;
    Application.BringToFront;

  end;
end;
//------------- ^ Enf of Drag_Drop procs ^-------------------------------

procedure TFMain.FormShow(Sender: TObject);
var i,j:smallint; Param:string;
begin
  GUIFormatSettings:=TFormatSettings.Create;
  with GUIFormatSettings do begin  //for ShellListAddItem
    ShortDateFormat:='yyyy/MM/dd'; LongTimeFormat:='hh:mm:ss';
  end;
  ShellList.Details:=false;
  ShellList.Filter:='*.*'; //for GetSelectedFiles
  ReadGUIini;

  ETCounterLabel:=LabelCounter;

  i:=Screen.PixelsPerInch;
  AdvPanelETdirect.Height:=MulDiv(32,i,96);
  AdvPanelMetaBottom.Height:=MulDiv(32,i,96);
  MetadataList.DefaultRowHeight:=MulDiv(19,i,96);
  //This must be in OnShow event -for OnCanResize event (probably bug in XE2):
  GUIBorderWidth:=Width-ClientWidth; GUIBorderHeight:=Height-ClientHeight;
  case GUIsettings.GUIcolor of
    0: MGUIColorGreyClick(MGUIcolorGrey);
    1: MGUIColorGreyClick(MGUIcolorBlue);
    2: MGUIColorGreyClick(MGUIcolorGreen);
  end;
  //MGUIColorGreyClick(MGUIcolorGrey);
  AdvPageMetadata.ActivePage:=AdvTabMetadata;
  AdvPageFilelist.ActivePage:=AdvTabFilelist;

  if GUIsettings.EnableGMap then begin
    GoogleMapInit(WebBrowser1); AdvTabGoogleMap.Enabled:=true;
  end else AdvTabGoogleMap.Enabled:=false;

  if not SpeedBtnDetails.Down  then begin
    ShellList.Thumbnails:=true; CBoxDetails.Enabled:=false;
  end;
  i:=CBoxDetails.Items.Count-1;
  SpeedBtnColumnEdit.Enabled:=(CboxDetails.ItemIndex=i);
  WrkIniDir:=ExtractFileDir(Application.ExeName);
  if GUIsettings.UseExitDetails then CBoxDetailsChange(Sender);

  //GUI started as "Send to" or "Open with":
  if ParamCount=1 then begin
    Param:=ParamStr(1);
    if DirectoryExists(Param) then ShellTree.SelectedFolder:=Param //directory only
    else if FileExists(Param) then begin //file specified
      ShellTree.SelectedFolder:=ExtractFileDir(Param);
      Param:=LowerCase(ExtractFileName(Param));
      i:=0; j:=-1;
      while (i<ShellList.Items.Count) and (j=-1) do begin
        if Param=LowerCase(ShellList.Items[i].Caption) then j:=i; //i=selected file
        inc(i);
      end;
      if j<>-1 then begin
        ShellList.SetFocus;
        ShellList.ItemIndex:=j;
        ShellListClick(Sender);
      end else ShellTree.SetFocus;
    end;
  end else ShellList.SetFocus;
  //--------------------------
end;

procedure TFMain.RotateImgResize(Sender: TObject);
begin
  ShowPreview;
end;

procedure TFMain.ShellListAddItem(Item: TJamShellListItem; var CanAdd: Boolean);
var i,n,x: smallint;
   ETcmd: string;
   Tx: string;
   Fsize:UInt64; Fdate:TDateTime;
   sr:TSearchRec;
begin
  begin
    if SpeedBtnDetails.Down then begin
      i:=CBoxDetails.ItemIndex;
      case i of
      0: begin
           (* Don't use this:
           AssignFile(F,Item.FullPath); FileMode:=0;
           Reset(F); Fsize:=FileSize(F) div 1024; CloseFile(F);
           // because it doesn't work for FileSize>4GB *)
           FindFirst(Item.FullPath,faNormal,sr);
           Fsize:=sr.Size; FindClose(sr);
           if Fsize>0 then begin
             Fsize:=Fsize shr 10; //=div 1024
             if Fsize=0 then inc(Fsize);
           end;
           ETcmd:=FloatToStrF(FSize,ffNumber,15,0);
           while Length(ETcmd)<10 do ETcmd:=' '+ETcmd;
           Item.SubItems.Append(ETcmd+' KB');
           ETcmd:=UpperCase(ExtractFileExt(Item.FullPath));
           Delete(ETcmd,1,1);
           Item.SubItems.Append(ETcmd+' file');
           FileAge(Item.FullPath,Fdate,false);
           ETcmd:=DateTimeToStr(Fdate,GUIFormatSettings);
           Item.SubItems.Append(ETcmd);
         end;
      1: begin
           GetMetadata(Item.FullPath,false,false,false,false);
           with Item.SubItems,Foto do begin
             Tx:=ExifIFD.ExposureTime; while Length(Tx)<7 do Tx:=' '+Tx; Append(Tx);
             Tx:=ExifIFD.FNumber; while Length(Tx)<4 do Tx:=' '+Tx; Append(Tx);
             Tx:=ExifIFD.ISO; while Length(Tx)<5 do Tx:=' '+Tx; Append(Tx);
             Tx:=ExifIFD.ExposureBias; while Length(Tx)<4 do Tx:=' '+Tx; Append(Tx);
             Tx:=ExifIFD.FocalLength; while Length(Tx)<6 do Tx:=' '+Tx; Append(Tx);
             if (ExifIFD.Flash and $FF00)<>0 then begin
               if (ExifIFD.Flash and 1)=1 then Append('Yes') else Append('No');
             end else Append('');
             Append(ExifIFD.ExposureProgram);
             if IFD0.Orientation>0 then begin
               if (IFD0.Orientation and 1)=1 then Append('Hor.') else Append('Ver.');
             end; //else Append('');
           end;
         end;
      2: begin
           GetMetadata(Item.FullPath,true,false,true,false);
           with Item.SubItems,Foto do begin
             Append(ExifIFD.DateTimeOriginal);
             if GPS.Latitude<>'' then Append('Yes') else Append('No');
             Append(Xmp.CountryShown);
             Append(Xmp.ProvinceShown);
             Append(Xmp.CityShown);
             Append(Xmp.LocationShown);
           end;
         end;
      3: begin
           GetMetadata(Item.FullPath,true,false,false,false);
           with Item.SubItems,Foto do begin
             Append(IFD0.Artist); // Xmp.Creator);
             Append(Xmp.Rating);
             Append(Xmp.PhotoType);
             Append(Xmp.Event);
             Append(Xmp.PersonInImage);
           end;
         end;
      else begin
          ETcmd:='-s3'+CRLF+'-f';
          for n:=0 to High(FListColUsr) do ETcmd:=ETcmd+CRLF+FListColUsr[n].Command;
          ET_OpenExec(ETcmd,ExtractFilename(Item.FullPath));
          x:=High(FListColUsr);
          for n:=0 to x do begin
            ETcmd:=ETout[n]; Item.SubItems.Append(ETcmd);
          end;
        end;
      end;
    end;
  end;
end;

procedure TFMain.ShellListChange(Sender: TObject; Item: TListItem;
  Change: TItemChange);
begin
  // This event isn't executed when/after deleting files! -after deletion,
  // as soon some remained file is clicked, event is execuded.
  UpdateStatusBar_FilesShown;
end;

procedure TFMain.ShellListClick(Sender: TObject);
var i:smallint;
begin
  if ETopenReady then begin
    i:=ShellList.SelCount;
    MExportImport.Enabled:=(i>0);
    MModify.Enabled:=(i>0);
    MVarious.Enabled:=(i>0);
    SpeedBtnQuickSave.Enabled:=false;
    ShowMetadata; ShowPreview;
  end;
end;

procedure TFMain.ShellListCreateColumns(Sender: TObject);
var i,n:smallint;
begin
  if ShellList.ViewStyle=vsReport then begin
    i:=ShellList.Columns.Count-1;
    while i>0 do begin ShellList.Columns.Delete(i); dec(i); end;
    i:=CBoxDetails.ItemIndex;
    if SpeedBtnDetails.Down then with ShellList do begin
      case i of
      0: begin
           //Column[0].Width:=FListStdColWidth[0];
           Columns.Add;
           with Column[1] do begin
             Caption:='Size'; Width:=FListStdColWidth[1]; Alignment:=taRightJustify;
           end;
           Columns.Add;
           Column[2].Caption:='Type'; Column[2].Width:=FListStdColWidth[2];
           Columns.Add;
           Column[3].Caption:='Date modified'; Column[3].Width:=FListStdColWidth[3];
         end;
      1: begin
           for i:=0 to High(FListColDef1) do begin
             Columns.Add;
             Column[i+1].Caption:=FListColDef1[i].Caption;
             Column[i+1].Width:=FListColDef1[i].Width;
             if FListColDef1[i].AlignR>0 then Column[i+1].Alignment:=taRightJustify;
           end;
         end;
      2: begin
           for i:=0 to High(FListColDef2) do begin
             Columns.Add;
             Column[i+1].Caption:=FListColDef2[i].Caption;
             Column[i+1].Width:=FListColDef2[i].Width;
             if FListColDef2[i].AlignR>0 then Column[i+1].Alignment:=taRightJustify;
           end;
         end;
      3: begin
           for i:=0 to High(FListColDef3) do begin
             Columns.Add;
             Column[i+1].Caption:=FListColDef3[i].Caption;
             Column[i+1].Width:=FListColDef3[i].Width;
             if FListColDef3[i].AlignR>0 then Column[i+1].Alignment:=taRightJustify;
           end;
         end;
       else begin
          n:=Length(FListColUsr)-1;
          for i:=0 to n do begin
            Columns.Add;
            Column[i+1].Caption:=FListColUsr[i].Caption;
            Column[i+1].Width:=FListColUsr[i].Width;
            if FListColUsr[i].AlignR>0 then Column[i+1].Alignment:=taRightJustify;
          end;
        end;
      end;
    end;
  end;
end;

procedure TFMain.ShellListDeletion(Sender: TObject; Item: TListItem);
begin //event is executed for each deleted file -so make it fast!
  RotateImg.Picture.Bitmap.Handle:=0;
  MetadataList.Strings.Clear;
end;

procedure TFMain.ShellListKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Key=VK_UP) or (Key=VK_DOWN) then ShellListClick(Sender); // Up-Down arrow
  if (Key=Ord('A')) and (ssCtrl in Shift) then ShellListClick(Sender); //Ctrl+A
  if (Key=VK_PRIOR) or (Key=VK_NEXT) then ShellListClick(Sender); // PageUp/Down
end;

procedure TFMain.ShellListOperation(Sender: TObject;
  Operation: TJamShellOperations; Files: TStrings; Destination: string);
begin
  //on Rename SubItems become non-visible
  if Operation=[sopRename] then begin
    ShellList.FullRefresh;
    ShowMetadata; ShowPreview;
  end;
end;

procedure TFMain.ShellListPathChanged(Sender: TObject);
begin
  ShellList.ItemIndex:=-1;
  ShellListClick(Sender);
  ShowMetadata; ShowPreview;
end;

procedure TFMain.ShellTreeChange(Sender: TObject; Node: TTreeNode);
var i,n:smallint;
begin
  if not ET_StayOpen(ShellTree.SelectedFolder) then begin
    //XE2 bug: MessageDlg doesn't allow Caption:
    Application.MessageBox('ERROR: ExifTool not found!'
      +#10#13+'Metadata operations disabled.','ExifToolGUI',MB_OK or MB_ICONSTOP);
    AdvPageMetadata.Enabled:=false;
    AdvPanelETdirect.Enabled:=false;
    AdvPanelFileTop.Enabled:=false;
    MOptions.Enabled:=false;
    MExportImport.Enabled:=false;
    MModify.Enabled:=false;
    MVarious.Enabled:=false;
    n:=MProgram.Count;
    for i:=1 to n-2 do begin //dont disable Exit menu
      MProgram.Items[i].Enabled:=false;
    end;
  end;
  RSBarChart1.Values.Clear; RSBarChart2.Values.Clear;
  RSBarChart3.Values.Clear;
end;
//=========================== Show Metadata ====================================
procedure TFMain.ShowMetadata;
var i,n: integer;
  ETcmd: string;
  tx: string;
begin
  i:=ShellList.ItemIndex;
  if i>=0 then begin
    Caption:='ExifToolGUI - '+ShellList.SelectedFiles[0];
    if SpeedBtnQuick.Down then begin
      n:=Length(QuickTags)-1;
      ETcmd:='-s3'+CRLF+'-f';

      for i:=0 to n do begin
        tx:=QuickTags[i].Command;
        if UpperCase(LeftStr(tx,Length(GUI_SEP)))=GUI_SEP then tx:=GUI_SEP;
        ETcmd:=ETcmd+CRLF+tx;
      end;

      ET_OpenExec(ETcmd,ShellList.SelectedFiles[0]);

      if ETout.Count>0 then with MetadataList do begin
        Strings.Clear;
        for i:=0 to n do begin
          tx:=QuickTags[i].Command;
          if UpperCase(LeftStr(tx,Length(GUI_SEP)))=GUI_SEP then tx:='='+QuickTags[i].Caption
          else begin
            tx:=QuickTags[i].Caption;
            if RightStr(tx,1)='?' then begin
              if ETout[i]='-' then tx:=tx+'=*NO*' else tx:=tx+'=*YES*';
            end else
              tx:=QuickTags[i].Caption+'='+ETout[i];
          end;
          Strings.Append(tx);
        end;
      end;
    end else begin
      if MGroup_g4.Checked then ETcmd:='-g4'+CRLF else ETcmd:='-g1'+CRLF;
      if not MNotDuplicated.Checked then ETcmd:=ETcmd+'-a'+CRLF;
      if MShowSorted.Checked then ETcmd:=ETcmd+'-sort'+CRLF;
      if MShowHexID.Checked then ETcmd:=ETcmd+'-H'+CRLF;
      if ET_Options.ETLangDef='' then ETcmd:=ETcmd+'-S'+CRLF;
      if SpeedBtnExif.Down then ETcmd:=ETcmd+'-Exif:All';
      if SpeedBtnIptc.Down then ETcmd:=ETcmd+'-Iptc:All';
      if SpeedBtnXmp.Down then ETcmd:=ETcmd+'-Xmp:All';
      if SpeedBtnMaker.Down then ETcmd:=ETcmd+'-Makernotes:All'+CRLF+'-CanonVRD:All';
      if SpeedBtnAll.Down then begin
        ETcmd:=ETcmd+'-All:All'; //+CRLF+'-e';
        if not MShowComposite.Checked then ETcmd:=ETcmd+CRLF+'-e';
      end;

      if SpeedBtnCustom.Down then begin
        ETcmd:=ETcmd+'-f'+CRLF+CustomViewTags;
        i:=Length(ETcmd); SetLength(ETcmd,i-1); //remove last space char
        ETcmd:=StringReplace(ETcmd,' ',CRLF,[rfReplaceAll]);
        //if MShowComposite.Checked then ETcmd:=ETcmd+CRLF+'-composite:all';
      end;

      ET_OpenExec(ETcmd,ShellList.SelectedFiles[0]);
      i:=0;
      if ETout.Count=0 then begin
        ETout.Append('=ExifTool executed');
        ETout.Append('=No data');
      end else while i<ETout.Count do begin
        ETout[i]:=StringReplace(ETout[i],': ','=',[]); inc(i);
      end;

      with MetadataList do begin
        i:=Row; Row:=1; Strings.Clear; Strings.AddStrings(ETout);
        if RowCount>i then Row:=i else Row:=RowCount-1;
      end;
    end;
    //if LogErr then begin ETout.Clear; UpdateLogWin; end; //not after ETdirect
  end else begin
    Caption:='ExifToolGUI';
    with MetadataList do begin Row:=1; Strings.Clear; end;
    EditQuick.Text:=''; MemoQuick.Text:='';
  end;
end;
//==============================================================================

procedure TFMain.SpeedBtnChartRefreshClick(Sender: TObject);
var ext:string[7]; i:smallint;
begin
  for i:=Low(ChartFLength) to High(ChartFLength) do ChartFLength[i]:=0;
  for i:=Low(ChartFNumber) to High(ChartFNumber) do ChartFNumber[i]:=0;
  for i:=Low(ChartISO) to High(ChartISO) do ChartISO[i]:=0;
  case AdvRadioGroup1.ItemIndex of
   0: ext:='*.*';
   1: ext:='*.jpg';
   2: ext:='*.cr2';
   3: ext:='*.nef';
   4: ext:='*.pef';
  end;
  RSBarChart1.Values.Clear; RSBarChart2.Values.Clear; RSBarChart3.Values.Clear;
  //FStat.Caption:='Chart of '+FMain.ShellTree.SelectedFolder;
  Screen.Cursor:=-11; //=crHourGlass
  ChartFindFiles(ShellTree.SelectedFolder, ext, AdvCheckBox_Subfolders.Checked);
  Screen.Cursor:=0; //crDefault;

  ChartMaxFLength:=0;
  for i:=Low(ChartFLength) to High(ChartFLength) do begin
    if ChartFLength[i]>0 then begin
      if ChartFLength[i]>ChartMaxFlength then ChartMaxFLength:=ChartFLength[i];
      ext:=IntToStr(i);
      if i<100 then Insert('.',ext,Length(ext)) //58->5.8
               else SetLength(ext,Length(ext)-1);
      RSBarChart1.Values.Add(ChartFLength[i],ext);
    end;
  end;
  ChartMaxFLength:=Round(ChartMaxFLength*1.1); if ChartMaxFLength<5 then ChartMaxFLength:=5;

  ChartMaxFNumber:=0;
  for i:=Low(ChartFNumber) to High(ChartFNumber) do begin
    if ChartFNumber[i]>0 then begin
      if ChartFNumber[i]>ChartMaxFNumber then ChartMaxFNumber:=ChartFNumber[i];
      ext:=IntToStr(i); Insert('.',ext, Length(ext)); //40->4.0
      RSBarChart2.Values.Add(ChartFNumber[i],ext);
    end;
  end;
  ChartMaxFNumber:=Round(ChartMaxFNumber*1.1); if ChartMaxFNumber<5 then ChartMaxFNumber:=5;

  ChartMaxISO:=0;
  for i:=Low(ChartISO) to High(ChartISO) do begin
    if ChartISO[i]>0 then begin
      if ChartISO[i]>ChartMaxISO then ChartMaxISO:=ChartISO[i];
      ext:=IntToStr(i)+'0'; //80->800
      RSBarChart3.Values.Add(ChartISO[i],ext);
    end;
  end;
  ChartMaxISO:=Round(ChartMaxISO*1.1); if ChartMaxISO<5 then ChartMaxISO:=5;

  AdvRadioGroup2Click(Sender);
end;

procedure TFMain.SpeedBtnDetailsClick(Sender: TObject);
var i: smallint;
begin
  with ShellList do begin
    i:=ItemIndex;
    Enabled:=false; //-prevent multiple FullRefresh calls
    if SpeedBtnDetails.Down then ViewStyle:=vsReport
                            else Thumbnails:=true;
    Enabled:=true; FullRefresh;
    ItemIndex:=i;
  end;
  ShowMetadata; ShowPreview;
  CBoxDetails.Enabled:=SpeedBtnDetails.Down;
end;

procedure TFMain.SpeedBtnExifClick(Sender: TObject);
begin
  AdvPanelMetaBottom.Visible:=SpeedBtnQuick.Down;
  SpeedBtnQuickSave.Enabled:=false;
  //AdvPageFilelist.Enabled:=true;
  //AdvPageBrowse.Enabled:=true;
  ShowMetadata;
end;

procedure TFMain.SpeedBtnLargeClick(Sender: TObject);
var i,f:smallint;
begin
  i:=Screen.PixelsPerInch; f:=ShellList.ItemIndex;
  if SpeedBtnLarge.Down then begin
    MemoQuick.Clear; MemoQuick.Text:=EditQuick.Text; // MemoQuick.Lines.Append(EditQuick.Text);
    EditQuick.Visible:=false;
    AdvPanelMetaBottom.Height:=MulDiv(105,i,96);
    if f<>-1 then MemoQuick.SetFocus;
  end else begin
    EditQuick.Text:=MemoQuick.Text; // MemoQuick.Lines[0];
    AdvPanelMetaBottom.Height:=MulDiv(32,i,96);
    EditQuick.Visible:=true;
    if f<>-1 then EditQuick.SetFocus;
  end;
end;

procedure TFMain.SpeedBtn_ETclearClick(Sender: TObject);
begin
  CBoxETdirect.ItemIndex:=-1; CBoxETdirect.Repaint;
  //EditETdirect.Text:='';
  CBoxETdirectChange(Sender);
end;

procedure TFMain.SpeedBtn_ETdirectClick(Sender: TObject);
var i,h:smallint;
begin
  i:=Screen.PixelsPerInch;
  if SpeedBtn_ETdirect.Down then begin
    if SpeedBtn_ETedit.Down then h:=184 //min 181
                            else h:=105;
    AdvPanelETdirect.Height:=MulDiv(h,i,96);
    EditETdirect.SetFocus;
  end else begin
    AdvPanelETdirect.Height:=MulDiv(32,i,96);
    ShellList.SetFocus;
  end;
end;

procedure TFMain.SpeedBtn_ETdSetDefClick(Sender: TObject);
begin
  GUIsettings.ETdirDefCmd:=CBoxETdirect.ItemIndex;
end;

procedure TFMain.SpeedBtn_ETeditClick(Sender: TObject);
var h:smallint;
begin
  if SpeedBtn_ETedit.Down then h:=181 else h:=105;
  AdvPanelETdirect.Height:=MulDiv(h,Screen.PixelsPerInch,96);
end;

procedure TFMain.SpeedBtn_GeotagClick(Sender: TObject);
var i: integer; Lat,Lon: string[23];
  ETcmd:string;
begin
  if ShellList.SelectedFiles.Count>0 then begin
    Lon:=MapGetMarkerLocation(WebBrowser1);
    if Lon<>'' then begin
      i:=pos(',',Lon);  Lat:=Copy(Lon,1,i-1); Delete(Lon,1,i);
      ETcmd:='-GPS:All='+CRLF+'-GPS:GpsLatitudeRef=';
      if Lat[1]='-' then begin ETcmd:=ETcmd+'S'; Delete(Lat,1,1); end
                    else ETcmd:=ETcmd+'N';
      ETcmd:=ETcmd+CRLF+'-GPS:GpsLatitude='+Lat;
      ETcmd:=ETcmd+CRLF+'-GPS:GpsLongitudeRef=';
      if Lon[1]='-' then begin ETcmd:=ETcmd+'W'; Delete(Lon,1,1); end
                    else ETcmd:=ETcmd+'E';
      ETcmd:=ETcmd+CRLF+'-GPS:GpsLongitude='+Lon;

      if ET_OpenExec(ETcmd,GetSelectedFiles) then begin
        UpdateLogWin; ShowMetadata;
      end;
      DeleteTmpFile;
    end;
  end else ShowMessage('No file selected');
end;

procedure TFMain.SpeedBtn_GetLocClick(Sender: TObject);
begin
  EditMapFind.Text:=MapGetMarkerLocation(WebBrowser1);
end;

procedure TFMain.SpeedBtn_MapHomeClick(Sender: TObject);
begin
  MapGotoPlace(GUIsettings.DefGMapHome); EditMapFind.Font.Color:=clGray;
end;

procedure TFMain.SpeedBtn_MapSetHomeClick(Sender: TObject);
begin
  GUIsettings.DefGMapHome:=MapGetMarkerLocation(WebBrowser1);
end;

procedure TFMain.SpeedBtn_ShowOnMapClick(Sender: TObject);
var Lat,Lon: string[23];
  ETcmd:string;
begin
  if ShellList.SelectedFiles.Count>0 then begin
    ETcmd:='-s3'+CRLF+'-f'+CRLF+'-n';
    ETcmd:=ETcmd+CRLF+'-GPS:GpsLatitude'+CRLF+'-GPS:GpsLatitudeRef';
    ETcmd:=ETcmd+CRLF+'-GPS:GpsLongitude'+CRLF+'-GPS:GpsLongitudeRef';
    ET_OpenExec(ETcmd,ShellList.SelectedFiles[0]);
    if (ETout[0]<>'-') then begin
      Lat:=ETout[0]; if ETout[1]='S' then Insert('-',Lat,1);
      Lon:=ETout[2]; if ETout[3]='W' then Insert('-',Lon,1);
      MapGotoLocation(Lat,Lon);
    end else MapMarkerInvalid;
  end else ShowMessage('No file selected.');
end;

procedure TFMain.Splitter1CanResize(Sender: TObject; var NewSize: Integer;
  var Accept: Boolean);
var x:smallint;
begin
  if NewSize<=Splitter1.Left then begin //limit to min. Browse panel
    if NewSize<=Splitter1.MinSize then NewSize:=Splitter1.MinSize+1;
  end else with Splitter2 do begin      //limit to min. Filelist panel
    x:=Left-NewSize;
    if x<MinSize then NewSize:=Left-MinSize-5;
  end;
  StatusBar.Panels[0].Width:=NewSize+5;
end;

procedure TFMain.Splitter2CanResize(Sender: TObject; var NewSize: Integer;
  var Accept: Boolean);
begin
  if NewSize<320 then NewSize:=320; //limit to min. Metadata panel
  with StatusBar do Panels[1].Width:=Width-Panels[0].Width-NewSize;
end;

procedure TFMain.Splitter3CanResize(Sender: TObject; var NewSize: Integer;
  var Accept: Boolean);
begin //prevent NewSize=0 (disappearing Preview panel)
  if NewSize<=Splitter3.MinSize then NewSize:=Splitter3.MinSize+1;
end;

procedure TFMain.MapTrackBarChange(Sender: TObject);
begin
  MapZoom(IntToStr(MapTrackBar.Position));
end;

end.
